      SUBROUTINE CONVER
C
C     CONVERSION OF B INPUT TO U'S OR 'TYPE 4' U'S TO STANDARD U'S
C        (ORTEP 'TYPE 8' IS STANDARD)
C
      COMMON/ATPAR/X(150,3),WT(150),MULT(150),UOBS(150,6),SIGU(150,6),UC
     1ALC(150,6),NUORB(150),SIGB(150,6)
      COMMON//AIDX(3000)
      COMMON/CELLP/CD(12),RCD(12),VOL,VST,G(3,3)
      COMMON /CONT1/ISET,NO,NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,NTO
     1T,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,
     2 IEIG,IMAT, IOUT,IRECAL, IFREQ
      DIMENSION B11(150),B22(150),B33(150),B12(150),B13(150),B23(150)
      EQUIVALENCE (B11(1),AIDX(1)),(B22(1),AIDX(201))
      EQUIVALENCE (B33(1),AIDX(401)),(B12(1),AIDX(601))
      EQUIVALENCE (B13(1),AIDX(801)),(B23(1),AIDX(1001))
C
      TWPISQ = 19.7392088
      IF(IB.EQ.4) GO TO 30
      DO 10 I = 1,NTOT
      UOBS(I,1) = B11(I)*1./(TWPISQ*RCD(1)*RCD(1))
      UOBS(I,2) = B22(I)*1./(TWPISQ*RCD(2)*RCD(2))
      UOBS(I,3) = B33(I)*1./(TWPISQ*RCD(3)*RCD(3))
      UOBS(I,4) = B12(I)*0.5/(TWPISQ*RCD(1)*RCD(2))
      UOBS(I,5) = B13(I)*0.5/(TWPISQ*RCD(1)*RCD(3))
      UOBS(I,6) = B23(I)*0.5/(TWPISQ*RCD(2)*RCD(3))
   10 CONTINUE
      IF(IB.NE.0) RETURN
C          IB.EQ.0 IMPLIES EXPLICIT FACTOR OF 2 IN DEFINITION OF THE
C         OFF-DIAGONAL ELEMENTS OF B
      DO 20 I = 1,NTOT
      UOBS(I,4) = 2.0*UOBS(I,4)
      UOBS(I,5) = 2.0*UOBS(I,5)
      UOBS(I,6) = 2.0*UOBS(I,6)
   20 CONTINUE
      RETURN
   30 FAC = 1.0/(4.0*TWPISQ)
      DO 40 I = 1,NTOT
      DO 40 J = 1,6
      UOBS(I,J) = FAC*UOBS(I,J)
   40 CONTINUE
      RETURN
      END
