      SUBROUTINE DISCOR
C **** KNT changes, 20.IV.91-7.V.91 re sym-equiv atoms and
C ****    fixing so includes point group P1-bar ("IF" just after 120)
C ***  Revised 19/21.XII.89 to include rigid-body corrns to distances between
C ***     input atoms and sym-generated atoms
C *** NEW, SEPTEMBER/NOVEMBER 1985, FOR VARIOUS DISTANCE CORRECTIONS
C ***     REPLACES MUCH OF LIBCOR AND PART OF NRCOR
C ***  ATOMS WITH WEIGHT 800.0 ARE SKIPPED
C ***      (WT 999.9 NO LONGER SKIPPED, AS OF 27.I.87)
C
      COMMON//AIDX(3000)
      COMMON/AIDPAR/AX(150,3),AUOBS(150,6),AUCALC(150,6),WU(150,6),
     1  WU1(150,6)
      COMMON/AMPCLN/NVIB,ICSVIB,NVAT1(40),NVAT2(40),
     1 NCSVIB(10), DCOS(10,3)
      COMMON/AMPCLC/VBAT1(40),VBAT2(40),CSATNM(10,12)
      CHARACTER*4 CSATNM,VBAT1,VBAT2
      COMMON/ATPAR/X(150,3),WT(150),MULT(150),UOBS(150,6),SIGU(150,6),UC
     1ALC(150,6),NUORB(150),SIGB(150,6)
      COMMON/AXESN/ISPAX(15),LT(5,15),LAT(5,15)
      COMMON/AXESC/LBAT(5,15)
      CHARACTER*4 LBAT
      COMMON/NONAM/ NONAME(15,40)
      CHARACTER*4 NONAME
      COMMON/CELLP/CD(12),RCD(12),VOL,VST,G(3,3)
      COMMON /CONT1/ISET,NO,NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,NTO
     1T,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,
     2 IEIG, IMAT, IOUT, IRECAL, IFREQ
      COMMON/CONT2/NP1,NNP1,IORIG,IWU,INOPAR
      COMMON/CONT3/ISOLV,NTOTS,CONSLV,SUMW,RWUDI,RMS,RMU,gof,sumsig
      COMMON/CORDIN/ IRIDE, IMIN, IUNC,IHAT(150), NUNC(20),TUNC(20,3),
     1   TOR(3,3), XCG(3),IHPR
      COMMON/CORDIC/ RIDA(20), RIDB(20), AMIN1(20), AMIN2(20),
     1   UNC1(20), UNC2(20)
      COMMON/IAID1/IAIDX1(1000)
      COMMON/INOUTN/ NPAGE, KOUTP,  DIS, IATWT
      COMMON/INOUTC/ NAME1, ATNAME(150),TISET(20),TITLE,ITBL(29),NAME2
      COMMON/LOC/ VAF(7,3), PVEC(7,3), V5(7,3), VEC1(15,3)
      COMMON/LOCC/ ATNX(7,2), BLLARG(7)
      COMMON/SYM/SYMOP(23,3,3),TMAT(3,3),RTMAT(3,3),EPSIJK(3,3,3),
     1 SYML(3)
      COMMON/TMCSIS/TCIC(3,3),TCIU(3,3),TCINVC(3,3),TCINVU(3,3),SCG(3),
     1 OMIN(3,3), TROI(3,3)
C * * Make common IO assignments.
      COMMON/IOSET/LI,LO,LTB
      DIMENSION NNM(12),AUO(3,3),
     1 AHL(3,3), WTT(150), VCOS(3), XX(3),XXA(3), IZ1(5), IZ2(5), IGR(5)
      DIMENSION   AL(3,3),W(3,3),DEL(3),AAX(3),AXX(150,3)
      DIMENSION P(80),NAT(15,150),NRBP(150), MAT(40), VC(3), SIGP(80)
      DIMENSION NAFA(40), NONSY(15), AXMOM(15), PL(6)
      DIMENSION TRCU(150),X1(3),X2(3), ASY(6), ISY(6),STR(3), PHICOR(3)
      EQUIVALENCE (AHL(1,1),AIDX(2601)), (PL(1), AIDX(2621))
      EQUIVALENCE  (P(1),AIDX(801)), (NRBP(1),IAIDX1(850))
      EQUIVALENCE (SIGP(1), AIDX(881)), (WTT(1), AIDX(451))
      EQUIVALENCE (AXX(1,1), AIDX(1)), (AAX(1), AIDX(2685))
      EQUIVALENCE (NAFA(1),IAIDX1(766)), (TK,AIDX(797))
      EQUIVALENCE  (NONSY(1),IAIDX1(601))
      CHARACTER*4 XNM, ATNX, AN1,AN2, COD
      CHARACTER*4 NAME1, ATNAME, TISET,TITLE*80, ITBL*3, NAME2*5
      CHARACTER*4 RIDA,RIDB,AMIN1, AMIN2,UNC1,UNC2
      CHARACTER*1 ASY,STR
      CHARACTER*10 XYZ, XYZ1,XYZ2
      REAL MULT, MINCOR
      DATA  XYZ1/' X,  Y,  Z'/
      DATA XYZ2/'-X, -Y, -Z'/
C
 9000 FORMAT(T99,'CORRN FOR INTERNAL'/T56,'RIGID',T99,'MOTION FOR EACH A
     1RG',/T3,
     2 'UNIQUE', T25,'UNCORR',T36,'CORRD',T45,'SUM OF',T56,
     3 'BODY',T65,'ANHARM',T79,'B&L',T93,30('-')/T3,'ATOM 1',T13,
     4 'ATOM 2', T26,'DIST',T36,'DIST',T45,'CORRNS',T56,
     5 'CORRN',T65,'CORRN',T78,'CORRN',T90,3(3X,'GP CORRN')/)
 9001 FORMAT(1X, 4(A4,1X,I2,2X,A4,1X,I2,2X,F5.3,6X))
 9002 FORMAT(//,1H ,'CORRECTIONS TO UNIQUE DISTANCES SMALLER THAN ',
     1 F5.2, ' (IF FIRST ATOM LISTED LIES ON A SYMMETRY ELEMENT, SOME',/
     2 5X,'NON-UNIQUE DISTANCES MAY BE INCLUDED ALSO). ',
     3'SOME OTHER SPECIFIC DISTANCES MAY BE INCLUDED IF'
     4/5X,'CORRESPONDING ATOM PAIRS WERE SPECIFICALLY INPUT.')
 9003 FORMAT(1H )
 9005 FORMAT(1H ,'ONE OR MORE EIGENVALUES OF L ZERO OR NEGATIVE.  NO COR
     1RECTION FOR RIGID BODY MOTION')
 9010 FORMAT( 3X,'DISTANCES ARE IN ANGSTROMS.  IN COLUMN 8, "B&L" MEANS
     1 CORRECTION ACCORDING TO BUSING & LEVY (1964) ACTA 17, 142, WITH'/
     2 5X,'"RID" MEANING RIDING CORRECTION, "UNC" MEANING CORRECTION FOR
     3 INDEPENDENT OR UNCORRELATED MOTION, AND "MIN" MEANING MINIMUM'/
     4 5X,'"THERMAL MOTION" CORRECTION.  ONLY ONE OF THESE CORRECTIONS W
     5ILL BE INCLUDED FOR A SPECIFIED PAIR OF ATOMS IN A GIVEN RUN;'/
     6 5X,'IF MORE THAN ONE IS SPECIFIED, ONLY THE FIRST REQUESTED WILL
     6 BE ADDED IN.'/
     7 10X,'"**R" MEANS RIDING CORRN CALCD BUT NOT ADDED IN BECAUSE PAIR
     7 OF ATOMS IS IN AN ARG; TORS CORRN HAS PRIORITY'/10X,'A * NEXT TO
     7 THE COLUMN FOR A CORRECTION FOR INTERNAL MOTION INDICATES THAT TH
     8E CORRESPONDING AMPLITUDE '/8X,'WAS ZERO OR NEGATIVE.'//3X,
     8'ADDITION OF THE SEPARATE CORRECTIONS TO GET AN OVERALL CORRECTION
     8 (AS HERE) IMPLIES UNCORRELATED MOTION.  THIS MAY NOT BE VALID,'/
     95X,'BUT IS THE SIMPLEST ASSUMPTION. INTERPRET RESULTS CAUTIOUSLY!'
     9/3X,'REMEMBER TOO THAT APPLICATION OF ANY MODEL ALWAYS INVOLVES AS
     9SUMPTIONS, EVEN THOUGH THEY MAY BE IMPLICIT OR UNSTATED.'/)
 9015 FORMAT(1H ,'CAUTION: IF THE ANHARMONIC CORRECTION FOR BOND TO H OR
     1 D IS POSITIVE, DATA ARE SUSPECT.  IT SHOULD NORMALLY BE AROUND'/
     2 10X,'-0.015 TO -0.02 ANGSTROM.  SEE COMMENTS IN INSTRUCTIONS')
 9020 FORMAT(3X,A4,6X,A4,',',I2,3X,F7.4,4X,F6.3,3(3X,F7.4),5X,F7.4,1X,
     1 A3, 5X, I1,1X,F6.4,A1, 2(2X,I1,1X,F6.4,A1))
 9025 FORMAT(10X,'(FOR THIS INDEPENDENT-MOTION CORRECTION, ATOM 2 AT ',
     1 A10,', WITH TRANSLATIONS ',2(F5.2,', '),F5.2,')')
C  WHEN IMPLEMENTING THE 3-LETTER CODE, USE COD, DECLARED AS CHARACTER*4
C   AND ONE OF FOUR:  COD = 'RID', COD = 'MIN', COD = 'UNC', COD = '   '
C
      IRB = 0
C ***   IRB CHANGED TO 1 IF ANY L(I,I) IS NEGATIVE
      DO 5 I = 1,NTOTS
C ***  KNT changed NTOT to NTOTS in preceding statement, 20.IV.91
      TRCU(I) = AUOBS(I,1) + AUOBS(I,2) + AUOBS(I,3)
    5 CONTINUE
C ***  FIRST CALCULATE POSITIONS CORRECTED FOR RIGID-BODY MOTION
      DO 10 I = 1,3
      IF(AHL(I,I).LE.0.)  GO TO 100
   10 CONTINUE
      TRAL = 0.
      CALL VMLT(PL,AL)
      DO 15 I = 1,3
      TRAL = TRAL + AL(I,I)
   15 CONTINUE
      DO 20 I = 1,3
      DO 20 J = 1,3
      W(I,J) = 0.5*(SYMOP(1,I,J)*TRAL - AL(I,J))
   20 CONTINUE
      DO 50 K = 1,NTOTS
      DO 40 I = 1,3
      DEL(I) = 0.
      AAX(I) = AX(K,I)
      DO 30 J = 1,3
      DEL(I) = DEL(I) + W(I,J)*AX(K,J)
   30 CONTINUE
      AAX(I) = AAX(I) + DEL(I)
   40 CONTINUE
C          BACK-CORRECT FOR ORIGIN SHIFT OF AX(K,J) TO CENTER OF MASS
      DO 45 I = 1,3
      AXX(K,I) = SCG(I)
      DO 45 J = 1,3
      AXX(K,I) = AXX(K,I) + TCINVC(I,J)*AAX(J)
   45 CONTINUE
C ***  AXX(J,K) are now crystal coords for all atoms, corrd for r.-b. motion
   50 CONTINUE
      GO TO 101
  100 IF(NS.GE.(-1).OR.NS.EQ.(-3)) CALL OUTH6
      IRB = 1
      GO TO 102
  101 IF(NS.GE.-1.OR.NS.EQ.-3) CALL OUTH6
  102 WRITE(LO,9002) DIS
      IF(IRB.NE.0) WRITE(LO,9005)
      WRITE(LO,9010)
C ***    FOLLOWING STATEMENT PRINTED ONLY WHEN ANISO H,D PRESENT (IHPR.NE.0)
      IF(IHPR.NE.0) WRITE(LO,9015)
      WRITE(LO,9000)
C
      NT = 0
C ***   NT IS LINE-TALLY FOR PAGINATION
      DO 1501 J = 1,NTOT
      IF(WTT(J).EQ.800.) GO TO 1501
C ***  J WILL BE TALLY FOR FIRST ATOM (UNIQUE ONES ONLY)
      JJ = J + 1
      JJ1 = NTOTS
C ***  PREVIOUS LINE ALTERED FROM NTOT TO NTOTS FOR THIS VERSION
      DO 1500 M = JJ,JJ1
C  M IS TALLY FOR SECOND ATOM
      IF(WTT(M).EQ.800.) GO TO 1500
      D = SQRT((AX(J,1) - AX(M,1))**2 +(AX(J,2) - AX(M,2))**2
     1   + (AX(J,3) - AX(M,3))**2)
      IF(D.EQ.0.0) GO TO 1500
      IF(D.GE.DIS.AND.IUNC.EQ.0) GO TO 1500
C ***  CLEAR VARIOUS ITEMS BEFORE CHECK FOR EACH PAIR OF ATOMS
      COR = 0.
      IR = 0
      CORBL = 0.
      RBCOR = 0.
      ANHCOR = 0.
      RIDCOR = 0.
      MINCOR = 0.
      UNCOR = 0.
      COD = '    '
      DO 105 I = 1,6
      ISY(I) = 0
      ASY(I) = ' '
      IF(I.GT.5) GO TO 105
      IZ1(I) = 0
      IZ2(I) = 0
      IGR(I) = 0
      IF(I.GT.3) GO TO 105
      PHICOR(I) = 0.
      STR(I) = ' '
  105 CONTINUE
      IF(M.GT.NTOT) GO TO 110
      NM = 1
      IM = M
      GO TO 120
C *** NEXT 2 LINES NEEDED ONLY WHEN SEARCH BEYOND FIRST NTOT ATOMS
  110 NM = (M - NTOT - 1)/NA + 2
      IM = M - NTOT - NA*(NM-2)
  120 AN1 = ATNAME(J)
      AN2 = ATNAME(IM)
      NP2 = NM
C ***   Omit calc if distance too large, and if beyond asym unit and
C ***           IM.LT.J  (atom B ahead of atom A in orig list -- this
C ***           would just give duplicate calcs  (7.V.91)
      IF(D.LT.DIS.AND.(NM.EQ.1.OR.(NM.GT.1.AND.IM.GE.J))) GO TO 180
C ***  CHECK WHETHER WANT SPECIAL CALC FOR SOME DISTANCE EXCEEDING DIS
C ***  NOW CHECK TO SEE IF ATOM NAMES MATCH THOSE OF PAIRS FOR CORRN FOR
C ***       UNCORRELATED (INDEPENDENT) MOTION
C ***  HERE ONLY IF  IUNC.NE.0
      DO 130  N = 1,IUNC
      IF(AN1.NE.UNC1(N).OR.AN2.NE.UNC2(N)) GO TO 130
C ***   IF PREV CONDN FAILS, HAVE MATCH OF ATOM NAMES FOR BOTH ATOMS
      NN = N
      GO TO 135
  130 CONTINUE
      GO TO 1500
C ***  WANT CORRECTION FOR UNCORRELATED MOTION OF DISTANCE BETWEEN SOME
C ***    PAIR OF ATOMS INPUT.  MUST GET POSITION PARAMETERS UNLESS ALL
C ***    TRANSLATIONS ARE ZERO
  135 DO 140  I = 1,3
      IF(TUNC(NN,I).EQ.0.) GO TO 140
C ***  SOME TRANSLATIONAL COMPONENT NON-ZERO. MUST CALC POSN PARAMS
      GO TO 145
  140 CONTINUE
      GO TO 180
  145 DO 150 I = 1,3
C ***  Change M to IM in next two lines (May '91) so if beyond asym
C ***    unit generally, it will still look at orig posn for this corrn
      IF(NUNC(NN).LT.0)  X(IM,I) = - X(IM,I)
      XX(I) = X(IM,I) + TUNC(NN,I)
  150 CONTINUE
C ***  XX(I) ARE NOW THE CRYSTAL POSN PARAMS, CORRD FOR TRANSLATION
C ***  NOW MUST CONVERT THESE TO THE CRYSTAL CARTESIAN SYSTEM
C ***     AND HAVE THEM REL TO C OF MASS, SINCE OTHER AX(I,J) ARE
C ***  WANT TO GET POSITIONS FOR SECOND ATOM (IF TRANSLATION INVOLVED)
C ***     IN CRYSTAL CARTESIAN SYSTEM SO CAN USE AUOBS (ALSO IN THAT
C ***     SYSTEM) EASILY.  AUOBS INDEPENDENT OF TRANSLATIONAL SYM,
C ***     ALTHOUGH IT WILL VARY WITH ROTATION OR REFLECTION
      CALL MATVEC(TOR,XX,XXA)
      DO 160 I = 1,3
      XXA(I) = XXA(I) - XCG(I)
C ***   XCG(I) ARE COORDS OF C OF M IN CARTESIAN CRYST SYST (FROM INERT)
C ***    XXA(I) ARE NOW CARTES CRYST COORDS OF ATOM M REL TO C OF MASS
  160 CONTINUE
C ***  NOW CALCULATE DISTANCE BETWEEN ATOMS J AND M & DIR COS OF 'BOND'
      D = SQRT((AX(J,1) - XXA(1))**2 + (AX(J,2) - XXA(2))**2 +
     1   (AX(J,3) - XXA(3))**2)
      DO 165 I = 1,3
      VCOS(I) = (AX(J,I) - XXA(I))/D
  165 CONTINUE
C ***  CALCULATIONS JUST DONE INVOLVE AN ATOM PAIR WITH INDEPENDENT
C ***    (UNCORRELATED) MOTION.  NO RIGID-BODY OR INTERNAL MOTION CALCS
C ***    TO BE DONE FOR THIS PAIR
      GO TO 500
C ***  THIS BRANCH FOR DISTANCES SMALLER THAN 'DIS'
  180 DO 185  I = 1,3
C ***   GET DIRECTION COSINES OF THE 'BOND VECTOR'; CALL THEM VCOS(I)
      VCOS(I) = (AX(J,I) - AX(M,I))/D
  185 CONTINUE
C ***  WHEN IRB NON-ZERO, RIGID-BODY CORRN SKIPPED,
C ***      BECAUSE SOME L(I,I).LT.0
      IF(IRB.NE.0) GO TO 200
C ***  NOW CALCULATE DISTANCE CORRD FOR RIGID-BODY MOTION
      DO 190 N = 1,3
C ***   AXX are defined for ALL atoms; do not want IM here
      DEL(N) = AXX(J,N) - AXX(M,N)
  190 CONTINUE
      DDIS = 0.
      DO 195 N = 1,3
      DO 195 L = 1,3
      DDIS = DDIS + G(N,L)*DEL(N)*DEL(L)
  195 CONTINUE
      DIST = SQRT(DDIS)
      RBCOR = DIST - D
      COR = COR + RBCOR
C ***   RBCOR = CORRN FOR RIGID-BODY MOTION
  200 CONTINUE
C ***  TEST TO SEE IF ANHARMONIC CORRN WANTED (X-H BONDS ONLY)
C ***     BUT SKIP ANY ISOTROPIC ATOMS (UOBS(J,2) = 0.0 )
C ***     IF WANT NO ANHARM, WANT NO RIDING EITHER
      IF(UOBS(J,2).EQ.0.0.OR.UOBS(M,2).EQ.0.0) GO TO 320
      IF(IHAT(J).EQ.0.AND.IHAT(M).EQ.0) GO TO 320
C ***  ONLY IF ONE OF THE TWO ATOMS IS H (OR D) (IHAT.NE.0)
C ***  BUT DO NOT WANT IT FOR SHORT NON-BONDED H...H, D...D, H...D
C ***       I.E., ONE OF THE TWO ATOMS MUST BE OTHER THAN H OR D
      IF(IHAT(J).NE.0.AND.IHAT(M).NE.0) GO TO 320
C ***  NOW CALCULATE ANHARMONIC CORRECTION FOR H-X OR D-X BOND
      CALL VEMA(AUOBS,AUO,J)
      CALL VMAV(AUO,VCOS,SVOJ)
      CALL VEMA(AUOBS,AUO,M)
      CALL VMAV(AUO,VCOS,SVOM)
      ANHCOR = -3.0*(SVOJ - SVOM)
C ***  NOW CHECK TO SEE WHICH ATOM IS H OR D; IF IT IS J, THEN SIGN OF
C ***     ANHCOR IS CORRECT; IF IT IS M, REVERSE SIGN
      IF(IHAT(M).NE.0) ANHCOR = -ANHCOR
      COR = COR + ANHCOR
  300 CONTINUE
C ***  FOLLOWING SECTION IS FOR RIDING CORRECTION, AUTOMATIC FOR H OR D
C ***     BONDED TO A HEAVIER ATOM. USUALLY THE H OR D IS ATOM M (2ND
C ***     ATOM.  IF NOT, THEN IHAT(J) IS NON-ZERO (BOTH CAN'T BE)
      RIDCOR = 0.5*(TRCU(M) - SVOM - (TRCU(J) - SVOJ))/D
      IF(IHAT(J).NE.0) RIDCOR = - RIDCOR
C ***  CORRN NOT ADDED IN UNTIL SURE ATOM PAIR IS NOT IN AN A.R.G.
      CORBL = RIDCOR
C ***    BUT DO NOT CALC (OR LABEL) WHEN ATOM IS ISOTROPIC
      COD = 'RID'
C ***  ONCE HAVE (ANHARMONIC AND) RIDING CORRN FOR X-H OR X-D BOND,
C ***    NO OTHER B&L CORRECTION WANTED, SO SKIP TO 600
      GO TO 600
  320 CONTINUE
C ***   THIS PATH FOR RIDING CORRECTIONS FOR ATOM PAIRS SPECIFIED ON
C ***       INPUT
      IF(IRIDE.EQ.0) GO TO 400
      DO 330 I = 1, IRIDE
      IF(RIDA(I).EQ.ATNAME(J).AND.RIDB(I).EQ.ATNAME(M)) GO TO 335
      IF(RIDA(I).EQ.ATNAME(M).AND.RIDB(I).EQ.ATNAME(J)) GO TO 340
  330 CONTINUE
C ***  NO MATCH OF CURRENT ATOM NAMES WITH ANY INPUT PAIR OF ATOMS FOR
C ***      RIDING CORRECTION
      GO TO 400
  335 JK = J
      MK = IM
      GO TO 345
C ***   THE RIDING ATOM, RIDA ON INPUT, IS JK FOR THE CORRECTION BELOW
  340 JK = IM
      MK = J
  345 CALL VEMA(AUOBS,AUO,JK)
      CALL VMAV(AUO,VCOS,SVO1)
      CALL VEMA(AUOBS,AUO,MK)
      CALL VMAV(AUO,VCOS,SVO2)
      RIDCOR = 0.5*(TRCU(JK) - SVO1 - (TRCU(MK) - SVO2))/D
C ***  SET MARKER TO INDICATE THAT A RIDING CORRN HAS BEEN CALCULATED
      ISY(1) = 1
  400 CONTINUE
C ***   NOW BEGIN MINIMUM THERMAL MOTION CORRECTIONS
      IF(IMIN.EQ.0) GO TO 500
      DO 430 I = 1, IMIN
      IF(AMIN1(I).EQ.ATNAME(J).AND.AMIN2(I).EQ.ATNAME(IM)) GO TO 445
      IF(AMIN1(I).EQ.ATNAME(IM).AND.AMIN2(I).EQ.ATNAME(J)) GO TO 445
  430 CONTINUE
C ***  NO MATCH OF CURRENT ATOM NAMES WITH ANY INPUT PAIR OF ATOMS FOR
C ***      MINIMUM 'THERMAL MOTION' CORRECTION
      GO TO 500
  445 CALL VEMA(AUOBS,AUO,J)
      CALL VMAV(AUO,VCOS,SVOJ)
      CALL VEMA(AUOBS,AUO,IM)
      CALL VMAV(AUO,VCOS,SVOM)
      MINCOR = 0.5*(TRCU(J) - SVOJ + TRCU(IM) - SVOM -
     1     2.0*SQRT((TRCU(J) - SVOJ)*(TRCU(IM) - SVOM)))/D
C ***  SET MARKER TO INDICATE THAT MINIMUM CORRN HAS BEEN CALCULATED
      ISY(2) = 1
  500 CONTINUE
C ***   NOW BEGIN CORRECTIONS FOR UNCORRELATED (INDEPENDENT) MOTION
      IF(IUNC.EQ.0) GO TO 600
      DO 530 I = 1, IUNC
      IF(UNC1(I).EQ.ATNAME(J).AND.UNC2(I).EQ.ATNAME(IM)) GO TO 545
      IF(UNC1(I).EQ.ATNAME(IM).AND.UNC2(I).EQ.ATNAME(J)) GO TO 545
  530 CONTINUE
C ***  NO MATCH OF CURRENT ATOM NAMES WITH ANY INPUT PAIR OF ATOMS FOR
C ***      CORRECTION FOR UNCORRELATED MOTION
      GO TO 600
  545 CALL VEMA(AUOBS,AUO,J)
      CALL VMAV(AUO,VCOS,SVOJ)
      CALL VEMA(AUOBS,AUO,IM)
      CALL VMAV(AUO,VCOS,SVOM)
      UNCOR = 0.5*(TRCU(J) - SVOJ + TRCU(IM) - SVOM)/D
C ***  SET MARKER TO INDICATE THAT CORRN FOR INDEP MOTION HAS BEEN CALCD
      ISY(3) = 1
  600 CONTINUE
      IF(NONRIG.EQ.0) GO TO 800
C ***   NOW BEGIN THE CORRECTIONS FOR TORSIONAL MOTION
C ***   ASSUMPTION IS MADE THAT THE VALUE FOUND FOR (PHI SQUARED +
C ***      2.0*PHI-LAMBDA PARALLEL) IS JUST PHI SQUARED, THAT IS, THAT
C ***      CORRELATION WITH OVERALL PARALLEL MOTION IS ZERO.  THIS IS
C ***      CLEARLY NOT GENERALLY WARRANTED, BUT WHEN THE MOTION IS LARGE
C ***      IT MAY NOT BE A BAD APPROXIMATION, AND WHEN THE MOTION IS
C ***      SMALL, THE CORRECTIONS ARE SMALL -- COMPARABLE, INDEED, TO
C ***      THEIR OWN ESTIMATED PRECISION, SO THE ERROR MADE IS SCARCELY
C ***      SIGNIFICANT.
      IF(J.GT.NA.OR.M.GT.NA) GO TO 800
C ***  ONLY HAVE CORRNS FOR TORSIONAL MOTION FOR ATOMS INCLUDED IN THE
C ***    'THERMAL MOTION ANALYSIS', I.E., THE FIRST NA UNIQUE ATOMS
      IF(NRBP(J).EQ.0.AND.NRBP(M).EQ.0) GO TO 800
C *** AT LEAST ONE OF THE ATOMS MUST BE AN AFFECTED ATOM OF SOME ARG,
C ***    OR NO CORRECTION TO BE MADE
      J1 = 0
      J2 = 0
      NJ = NRBP(J)
      DO 610 I = 1,5
      IH = NJ/16
      IZ1(I) = NJ - 16*IH
      IF(IZ1(I).EQ.0) GO TO 620
      NJ = IH
      J1 = J1 + 1
  610 CONTINUE
  620 NM = NRBP(M)
      DO 630 I = 1,5
      IH = NM/16
      IZ2(I) = NM - 16*IH
      IF(IZ2(I).EQ.0) GO TO 632
      NM = IH
      J2 = J2 + 1
  630 CONTINUE
C *** IS EITHER ATOM THE 2ND AXIS-DEFINING ATOM OF SOME ARG?
  632 DO 638 I = 1,NONRIG
      LLL = LT(2,I)
      IF(ISPAX(I).NE.0) LLL = LT(5,I)
      IF(J.NE.LLL) GO TO 635
      J1= J1 + 1
      IZ1(J1) = I
  635 IF(M.NE.LLL) GO TO 638
      J2 = J2 + 1
      IZ2(J2) = I
  638 CONTINUE
C ***  CORRN ONLY IF EACH ATOM IS IN AN ARG (OR IS 2ND AXIS-DEF ATOM)
C ***  UNLESS J1.GT.0, J IS NOT; UNLESS J2.GT.0, M IS NOT
      IF(J1.EQ.0.OR.J2.EQ.0) GO TO 800
C ***  NOW HAVE THE NUMBER OF ARG'S THAT ATOM J IS IN (J1) AND THAT
C ***      ATOM M IS IN (J2), AND THE SERIAL NOS OF THESE GROUPS
C ***      AS IZ1(K), K = 1,J1 AND  IZ2(L), L = 1,J2
C ***      [2ND AXIS-DEFINING ATOM INCLUDED HERE FOR EACH ARG]
C ***  IF, AND ONLY IF, THE TWO ATOMS ARE IN THE SAME ARG, WANT TO
C ***      CALCULATE THE CORRECTION TO J-M DIST FOR MOTION OF THAT ARG
  640 IR = 0
      DO 650 K = 1,J1
      DO 650 L = 1,J2
      IF(IZ1(K).NE.IZ2(L)) GO TO 650
C ***  ATOMS ARE IN SAME GROUP; SAVE THAT GROUP NUMBER AS IGR(I)
      IR = IR + 1
      IGR(IR) = IZ1(K)
  650 CONTINUE
C ***  IGR GIVEN DIMENSION OF 5 FOR SAFETY, BUT PROGRAM ONLY DOES
C ***     CALCS FOR UP TO THREE GROUPS WITH ATOMS IN COMMON (ONLY
C ***     PROVISION FOR THAT MANY IN DERNON), SO ANY GIVEN PAIR CANNOT
C ***     BE IN MORE THAN 3 DIFFERENT GROUPS
      IF(IR.EQ.0) GO TO 900
C ***  IF IR = 0, THERE WERE NO GROUPS WITH THESE TWO ATOMS; IR IS THE
C ***     NUMBER OF GROUPS CONTAINING THESE TWO ATOMS
      DO 700 II =1,IR
      N = IGR(II)
C ***   N IS NOW THE SERIAL NUMBER OF THE GROUP CONTAINING THESE ATOMS
      KK = N + NP1
      IF(P(KK).GT.0) GO TO 660
C ***  IF PHI-SQ + 2 PHI-LAMBDA PARALLEL 0 OR NEG, SKIP CALC FOR GROUP
C ***      AND MARK THE PLACE WHERE CORRECTION WOULD NORMALLY BE LISTED
      STR(II) = '*'
      GO TO 700
  660 VC(1) = VEC1(N,2)*VCOS(3) - VEC1(N,3)*VCOS(2)
      VC(2) = VEC1(N,3)*VCOS(1) - VEC1(N,1)*VCOS(3)
      VC(3) = VEC1(N,1)*VCOS(2) - VEC1(N,2)*VCOS(1)
      SVC = 0.0
      DO 670 IJ = 1,3
      SVC = SVC + VC(IJ)*VC(IJ)
  670 CONTINUE
C ***  SVC IS SQUARE OF SINE OF ANGLE BETWEEN VECTOR FROM ATOM J TO ATOM
C ***     M AND THE AXIS OF THE "NON-RIGID GROUP" (ATTACHED RIGID GROUP)
C ***  D IS THE DISTANCE BETWEEN ATOMS J AND M (CALCULATED EARLIER)
      PHICOR(II) = 0.5*D*SVC*P(KK)
  700 CONTINUE
  800 CONTINUE
      IF(IHAT(J).NE.0.OR.IHAT(M).NE.0) GO TO 900
C ***  IF EITHER ATOM IS H, HAVE ALREADY CALCD RIDING CORRECTION, AND
C ***     ONLY ONE KIND OF BUSING-LEVY CORRECTION APPROP FOR GIVEN ATOM
C ***  NOW SUM CORRECTIONS (INCLUDING ONLY ONE B&L TYPE) AND SET
C ***    ANY NEEDED INDICATORS FOR PRINTING LINE.  HAVE ALREADY SUMMED
C ***      RBCOR, AND, FOR H OR D, ANHCOR
C ***     FIND OUT WHICH B&L CORRN CALCD; ADD IN FIRST ONE IN SEQ
      IF(ISY(1).EQ.0) GO TO 820
C ***  ISY(1) NON-ZERO MEANS RIDING CORRN CALCULATED FOR INPUT PAIR
      COD = 'RID'
      CORBL = RIDCOR
      IF(IR.NE.0) THEN
       COD = '**R'
      ELSE
       COR = COR + RIDCOR
      ENDIF
      GO TO 900
  820 IF(ISY(2).EQ.0) GO TO 840
C ***  ISY(2) NON-ZERO MEANS MINIMUM CORRECTION CALCULATED
      COD = 'MIN'
      CORBL = MINCOR
      COR = COR + MINCOR
      IF(ISY(1).NE.0) ASY(2) = '*'
C ***  PRECEDING SETS AN INDICATOR IN CASE HAVE ROOM TO PRINT THE
C ***     MIN CORRN EVEN IF DO NOT INCLUDE IT IN SUM OF CORRNS BECAUSE
C ***     RIDING CORRN HAS BEEN INCLUDED
C *** AT PRESENT (23.X.85) THERE IS NO PROVISION FOR PRINTING ALL OF
C ***   CORRECTIONS CALCULATED; NOTE THAT IF WANT TO DO THAT, MUST
C ***   ALTER VARIOUS LINES HERE (INCLUDING   CORBL = ... ) SO THAT
C ***   ONLY THE ONE DESIRED CORRECTION IS ADDED IN
      GO TO 900
  840 IF(ISY(3).EQ.0) GO TO 900
C ***  ISY(3) NON-ZERO MEANS CORRN FOR UNCORRELATED MOTION CALCD
      COD = 'UNC'
      CORBL = UNCOR
      IF(ISY(1).NE.0.OR.ISY(2).NE.0) ASY(3) = '*'
C ***  PRECEDING SETS AN INDICATOR IN CASE HAVE ROOM TO PRINT THE
C ***     UNC CORRN EVEN IF DO NOT INCLUDE IT IN SUM OF CORRNS BECAUSE
C ***     RIDING OR MINIMUM CORRN HAS BEEN INCLUDED
      COR = COR + UNCOR
  900 CONTINUE
      IF(IHAT(J).NE.0.AND.IHAT(M).NE.0) GO TO 915
      IF(IHAT(J).EQ.0.AND.IHAT(M).EQ.0) GO TO 915
C ***  IF EITHER ATOM IS H OR D (BUT NOT BOTH), AND PAIR IS IN AN ARG,
C ***     DO NOT WANT RIDING CORRN (ALREADY CALCD ABOVE) ADDED IN
      IF(COD.EQ.'RID') COD = '**R'
      IF(IR.NE.0) GO TO 917
C ***   WHEN IR = 0, THIS PAIR OF ATOMS IS IN NO ARG
C ***      BUT NO RIDING CORRN WHEN THE H OR D IS ISOTROPIC
  910 COD = 'RID'
      IF(UOBS(J,2).EQ.0.0.OR.UOBS(M,2).EQ.0.)  COD = '    '
      IF(UOBS(J,2).NE.0.0.AND.UOBS(M,2).NE.0.) COR = COR + RIDCOR
      GO TO 1000
C *** IR = NUMBER OF GROUPS CONTAINING THIS PAIR OF ATOMS
C ***   IF IR = 0, NO CORRNS FOR TORSIONAL MOTION FOR THIS PAIR
  915 IF(IR.EQ.0) GO TO 1000
  917 DO 920 II = 1,IR
      COR = COR + PHICOR(II)
  920 CONTINUE
      DCOR = D + COR
      WRITE(LO,9020) AN1,AN2,NP2, D, DCOR,COR, RBCOR,ANHCOR, CORBL,COD,
     1  (IGR(II),PHICOR(II),STR(II), II = 1,IR)
      IF(IUNC.EQ.0.OR.ISY(3).EQ.0) GO TO 1300
      XYZ = XYZ1
C *** THE SERIAL NO OF THIS "UNC" PAIR HAS BEEN SAVED AS   NN
      IF(NUNC(NN).LT.0) XYZ = XYZ2
      WRITE(LO,9025) XYZ, (TUNC(NN,II), II = 1,3)
      NT = NT + 1
      GO TO 1300
 1000 CONTINUE
      DCOR = D + COR
 1200 WRITE(LO,9020) AN1,AN2,NP2, D, DCOR,COR, RBCOR,ANHCOR, CORBL,COD
      IF(IUNC.EQ.0.OR.ISY(3).EQ.0) GO TO 1300
      XYZ = XYZ1
      IF(NUNC(NN).LT.0) XYZ = XYZ2
      WRITE(LO,9025) XYZ, (TUNC(NN,II), II = 1,3)
      NT = NT + 1
 1300 NT = NT + 1
      IF(NT.LT.48) GO TO 1500
      NT = 1
      CALL OUTH6
      WRITE(LO,9000)
 1500 CONTINUE
 1501 CONTINUE
      RETURN
      END
