      PROGRAM THMA11
C *** Changes in CALCUS and UCRYST, 7.X.91
C *** One-line change in CALCUS, two-line change in LOCAL 7.VI.91
C ***  KNT changes in MAIN and DISCOR re printing RMU and corrns when have
C ***     sym-equiv atoms 20.IV.91; and in SOLVE, just after 25
C ***** EFM worked on this version (3/91) to improve delta MSDA output
C ***** CHANGES IN OUTR and OUTP and SYMPOS -- find by search for C *****
C ***** CHANGES ARE IN SUBROUTINE VIBAMP and INERT
C ***    Moved RMU and RMS to COMMON/CONT3/ from EQUIV statements 15.IV.91
C ***    MSDA output was rounded twice in VIBAMP full table (fixed 1.V.91)
C ***  THIS IS A SIGNIFICANTLY UPDATED VERSION OF THMA10
C ***    15.IV.91  Moved RMU, RMS out of EQUIV into COMMON/CONT3/
C ***    Revised DISCOR, 19-21.XII.89, to include unique distances between
C ***      input atoms and sym-generated atoms for rigid-body corrections
C ***    CHANGES IN OUTR on 15.I.90 to output total mean sq ampl of libration
C ***      of ARG (= L parallel to ARG axis + phi-sq + 2<phi-lambda parallel>)
      CHARACTER*12, FILE1
C * * PC modifications search C * * P. Boyle University of New Brunswick 1/92
C * * Search C PB for commenting out of original code for modifications other
C * * than IO modifications.
      COMMON//AIDX(3000)
      COMMON/AMPCLN/NVIB,ICSVIB,NVAT1(40),NVAT2(40),
     1 NCSVIB(10), DCOS(10,3)
      COMMON/AMPCLC/VBAT1(40),VBAT2(40),CSATNM(10,12)
      CHARACTER*4 CSATNM,VBAT1,VBAT2
      COMMON/AIDPAR/AX(150,3),AUOBS(150,6),AUCALC(150,6),WU(150,6),
     1WU1(150,6)
      COMMON/AMAT/AN(80,80)
      COMMON/ATPAR/X(150,3),WT(150),MULT(150),UOBS(150,6),SIGU(150,6),UC
     1ALC(150,6),NUORB(150),SIGB(150,6)
      COMMON/CELLP/CD(12),RCD(12),VOL,VST,GST(3,3)
      COMMON /CONT1/ISET,NO,NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,NTO
     1T,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,
     2 IEIG, IMAT, IOUT, IRECAL, IFREQ
      COMMON/CONT2/NP1,NNP1,IORIG,IWU,INOPAR
      COMMON/CONT3/ISOLV,NTOTS,CONSLV,SUMW,RWUDI,RMS,RMU,gof,sumsig
      COMMON/FORM/IFMX,IFMB, ILIST
C     COMMON/FORMC/ FMTX(18), FMTB(18)
      COMMON/IAID1/ IAIDX1(1000)
      COMMON/INOUTN/ NPAGE, KOUTP,  DIS, IAW
      COMMON/INOUTC/ NAME1, ATNAME(150),TISET(20),TITLE,ITBL(29),NAME2
C * * Make COMMON IO assignments
      COMMON/IOSET/LI,LO,LTB
      COMMON/IPAR/ NP(80)
      COMMON/SYM/SYMOP(23,3,3),TMAT(3,3),RTMAT(3,3),EPSIJK(3,3,3),
     1 SYML(3)
      COMMON/TMCSIS/TCIC(3,3),TCIU(3,3),TCINVC(3,3),TCINVU(3,3),SCG(3),
     1 OMIN(3,3), TROI(3,3)
      DIMENSION SIGP(80)
      DIMENSION NRBP(150)
      EQUIVALENCE  (ETA,AIDX(1201))
C      THIS IS USED FOR ETA UNTIL AFTER INERT IS CALLED FIRST TIME
C      (NEEDED IN SGTRAN)
      EQUIVALENCE (SIGP(1),AIDX(881))
      EQUIVALENCE (SUMSGU,AIDX(2486))
      EQUIVALENCE(IATEX,IAIDX1(500))
      EQUIVALENCE (IPAREX,IAIDX1(500)), (NRBP(1),IAIDX1(850))
      CHARACTER*4 NAME1, ATNAME, TISET, TITLE*80, ITBL*3, NAME2*5
C * * Character declaration for date and time string.
      CHARACTER PBTIME*26 
      REAL   MULT
      DOUBLE PRECISION AN
C
      CALL TIMDAT(PBTIME)
C *** PRESET IFU1 TO ZERO BEFORE FIRST RUN; IF TO CONTINUE WITH SAME
C ***    ATOMIC PARAMETERS, IT WILL THEN BE SET = IRECAL FOR ANY
C ***    GIVEN RUN AT END OF THAT RUN (SEE END OF MAIN PROGRAM)
      IFU1 = 0
    1 NPAGE = 0
C
C * * Set I/O unit numbers.
      LI=1
      LO=3
      LTB=4
C
C * * Prompt user for name of input file.
C
      PRINT *,'Enter name of THMA11 input file in single quotes.'
      READ *,FILE1
      OPEN(LI,FILE=FILE1,FORM='FORMATTED',STATUS='OLD')
      OPEN(LO,FILE='thma11.out',STATUS='UNKNOWN')
      OPEN(LTB,FILE='msda.tbl',STATUS='UNKNOWN')
      WRITE(LO,101) 
  101 FORMAT('THMA11 for linux (based on IBM VERSION OF Oct 8, 1991,
     &14:10 )' )
      WRITE(LO,102) PBTIME
  102 FORMAT('JOB RUN ON ',A24)
      IWU = 0
      ISOLV = 0
      CALL RDIN1
C     READ TITLE LINE AND CELL DIMENSIONS, CODE WORDS FOR SPECIFYING
C        VARIABLE INPUT FORMATS FOR X,Y,Z AND FOR B'S OR U'S, AND
C        VALUES OF ETA AND DIS IF DEFAULT VALUES NOT TO BE USED
      CALL OUTH6
C     PRINT TITLE
      IF(IFU1.EQ.0)  CALL CELLDI
C     CALCULATE REAL AND RECIPROCAL CELL
      CALL OUTP12
C     PRINT CELL DIMENSIONS
      CALL RDIN2
C     READ CONTROL LINE AND IF NECESSARY SYM.TRANSF.MATRICES TMAT, RTMAT
      CALL OUTP14
C     PRINT CONTROL LINE INFORMATION AND IF SUBMITTED TMAT AND RTMAT
C     WITH SUBMITTED TITLE FOR SPECIAL SETTING
      IF(NTOT.LE.150)  GO TO 20
      CALL OUTH13
C     TOO MANY ATOMS
      CALL EXIT
   20 IF(IB.EQ.0.OR.IB.EQ.1) GO TO 95
      IF(IB.EQ.4.OR.IB.EQ.8) GO TO 95
C        EXIT IF IB HAS VALUE OTHER THAN 0, 1, 4, OR 8.
   25 FORMAT(38H0  IB VALUE OTHER THAN 0, 1, 4, OR 8.    )
      WRITE(LO,25)
      CALL EXIT
C     READ COORD.,AT.WEIGHTS, U(I,J) OR B(I,J),NUORB(I)
   95 IF(IFU1.EQ.0) THEN
C *** IF IFU1 NON-ZERO, THIS IS 2ND (OR LATER) RUN WITH SAME AT. PARAMS
       CALL RDIN3
       DO 90 I = 1,NTOT
        IF(MULT(I).EQ.0.0) MULT(I) = 1.0
        MULT(I) = 1./MULT(I)
   90  CONTINUE
      ENDIF
      IF(IB.NE.8)  CALL CONVER
      IF(IFU1.EQ.0) THEN
C   WHEN IFU NON-ZERO, ATOMS ALREADY SORTED (2ND OR LATER RUN)
       CALL SORT
C     SORT ATOMS INTO SEQUENCE  POS.WT,ZERO WT,NEG.WT,WT 999.9
C     COUNT NUMBER OF INDEPENDENT OBSERVATIONS
       NINOBS = 0
       DO 10 J = 1,NA
        IF(NUORB(J).EQ.0)  NUORB(J) = 6
        IF(WT(J).EQ.800.0) NUORB(J) = 0
C   DUMMY ATOMS (WT = 800.) SHOULD NOT CONTRIBUTE TO CALC OF
C     NUMBER OF INDEP OBSERV.  ATOMS WITH WT 999.9 OR NEGATIVE
C     HAVE ALREADY BEEN PLACED AT END (NOT IN COUNT NA) BY 'SORT'.
        NINOBS = NINOBS + NUORB(J)
   10  CONTINUE
      ENDIF
      NSIG = IABS(ISIG)
      IF(IFU1.NE.0) GO TO 140
      CALL OUTH6
      CALL OUTH8
      KOUTP = 1
      CALL OUTP15
C     PRINT COORD.,UOBS,WT
      IF(ISIG.EQ.0)  GO TO 140
      CALL RDIN5
C     READ SIGMA U'S, ATOMNAME IN SEQUENCE SIGU11,SIGU22,...SIGU23,ATNAM
C      THESE ASSUMED TO BE SIG(B) IF IB = 0 OR 1 ; converted in RDIN5
      CALL SORTSG(NSIG)
C ***   SORTSG   SORTS ESD'S INTO SAME ORDER AS THAT DONE BY   SORT
C ***     IT ALSO GENERATES SIGU(I,K) = 1.0 FOR ATOMS OF WEIGHT 800 IF
C ***     NO ESD'S WERE INPUT FOR THOSE ATOMS.
      IF(NTOT.GT.20) CALL OUTH6
C      NEW PAGE IF MORE THAN 20 ATOMS
      CALL OUTH21
      KOUTP = 2
      CALL OUTP17
      IF(ISIG.LE.0)  GO TO 140
C ***   IF ISIG NEGATIVE, INPUT WORKING WEIGHTS FOR ATOMS
  145 SUMSIG = 0.
      SUMSGU = 0.
C ***  SUMSIG IS SUM OF ALL ESD TERMS; SUMSGU IS SUM OF SQUARES
      ISEG = NA - N8
C ***  CHANGE 14.I.87 -- ISEG NOW DEFINED AS ONLY THOSE ATOMS
C ***     INCLUDED IN THE ANALYSIS OF MOTION (NA - THOSE THAT
C ***     HAVE WEIGHT 800., WHICH IS N8)
      NSIGU = 0
      DO 155 I = 1,ISEG
      DO 155 K = 1,6
      SUMSIG = SUMSIG + SIGB(I,K)
      IF(SIGB(I,K).EQ.0.)  NSIGU = NSIGU + 1
C ***   NSIGU IS TALLY OF NUMBER OF ESD's INPUT AS 0.0 FOR ATOMS
C ***     OTHER THAN THOSE WITH WEIGHT 800. (CORRECTION FOR THEM
C ***     IS MADE SEPARATELY.)  IT IS USED ONLY IN THIS MAIN ROUTINE
      SUMSGU = SUMSGU + SIGB(I,K)*SIGB(I,K)
  155 CONTINUE
      SUMSIG = SUMSIG/FLOAT(6*ISEG - NSIGU)
C     SUMSIG GIVES MEAN SIGMA U, USED FOR THE WU(I,K)
C     SUMSGU WILL BE USED TO CALCULATE THE MEAN STANDARD DEVIATION OF
C        THE U'S.
C *** earlier here: IF SIGU = 0 ,REPLACE IT BY AVERAGE SIGU
  140 CALL RDIN4
C     READ INPUT FOR ATTACHED RIGID GROUPS (IF ANY) OR FOR DESIRED
C          CORRECTIONS FOR RIDING, MINIMUM, UNCORRELD MOTION
      IF (NONRIG.EQ.0) GO TO 80
      CALL OUTP16
C     PRINT NON-RIGID BODY INPUT
      CALL NRBPAR
C     PRODUCE LIST NRBP(150) OF NON-RIGID BODY MOTION PARAMETERS
C     AFFECTING EACH ATOM
      GO TO 100
   80 DO 85 I = 1,NTOT
      NRBP(I) = 0
   85 CONTINUE
  100 IF(NS.GE.0.AND.NONRIG.GT.2)  CALL OUTH6
      IF(ISYM.NE.0) CALL RDIN6
C      ISYM .NE.0 MEANS ORIGIN DOES NOT LIE ON ALL SYMMETRY ELEMENTS SO
C          MUST READ IN COORDINATES OF A POINT THAT DOES.
      IF(NVIB.GT.0.OR.ICSVIB.NE.0) CALL RDIN7
C      WHEN NVIB IS POSITIVE OR ICSVIB.NE.0, CALCULATION OF MEAN SQUARE
C        DISPLACEMENT AMPLITUDES FOR ATOMS IN CERTAIN DIRECTIONS WANTED.
      IF(NS.GE.0) CALL OUTP10
C     PRINT  NTOT, NA, NAH (= NUMBER OF ATOMS TO BE INTERPRETED ONLY)
C        THESE QUANTITIES ARE PRODUCED BY SUBROUTINE SORT
      IF(ISET.GT.5)  GO TO 105
      IF(NS.GE.0) CALL OUTH2
C     PRINT SETTING OF PRINCIPAL AXIS
      GO TO 115
  105 IF(NS.GE.0) CALL OUTH1
C     PRINT  TISET
  115 CALL SYMET     
C  ! WHICH CALLS SYMPOS, WHICH CALLS SGTRAN
C     CALCULATE SET OF COORDINATES FOR THE COMPLETE MOLECULE IN THE
C         DESIRED SETTING OF THE PRINCIPAL AXIS
      IF(IATEX.EQ.-1)  GO TO 997
      CALL NPAR
C ***  NPAR EVENTUALLY CALLS ORTHO, AND INERT, WHICH CALLS SGTRAN
      IF(NS.GE.(-1).OR.NS.EQ.(-3)) CALL DIST(NTOTS)
      CALL WEIGHT(NSIG)
      IF (NO.EQ.1) GO TO 160
C     SET NRBP(I) FOR THE EXPANDED SET OF ATOMS
      NTOT1 = NTOT + 1
      J1 = 0
      DO 165 K = NTOT1,NTOTS
      J1 = J1 + 1
      NRBP(K) = NRBP(J1)
      IF(J1.EQ.NA)  J1 = 0
  165 CONTINUE
  160 IF(NS.LT.0) GO TO 125
      IF(ISIG.EQ.0)  GO TO 120
C     PRINT SIGU IF INPUT.  THESE ARE NOW SIGU AFTER TRANSFORMATION TO
C        CARTESIAN SYSTEM (BY  SGTRAN , CALLED BY  INERT ).
      IF(IWU.NE.1) CALL OUTP21
  120 KOUTP = 3
      IF(ISIG.EQ.0.OR.NTOT.GT.20) CALL OUTH6
      CALL OUTH28
      CALL OUTP17
C     PRINT WORKING WEIGHTS OF U'S USED IN THE SOLUTION OF THE SYSTEM
C         OF LINEAR EQUATIONS
  125 NP1 = 21
      IF(NPARS.EQ.0)  NP1 = 12
      IF(NONRIG.EQ.0) GO TO 110
  130 DO 135 I = 1,NONRIG
      K = NP1 + I
C ***  NEXT LINE WAS FORMERLY   NP(K) = NP1 + NRBCON(I), BUT THE
C ***    PARAMETER CONSTRAINT "NRBCON" WAS MEANINGLESS; IT IS JUST I
      NP(K) = K
  135 CONTINUE
C ***  SET NP(I) FOR PARAMETERS BEYOND PHI-PHI FOR EACH NON-RIG GROUP
      MMM = NONRIG + NP1 + 1
      DO 137 I = MMM,80
  137 NP(I) = I
  110 CONTINUE
      IPAREX = 0
  190 IORIG = 1
  310 CALL SOLVE
C     SOLVE CALLS MANY SUBROUTINES , SETS UP SYSTEM OF NORMAL EQUATIONS
C        AND SOLVES IT.
      IF(IPAREX.NE.-1)  GO TO 200
      CALL OUTH22
C     NUMBER OF PARAMETERS EXCEEDS DIMENSION OF MATRIX OF EQUATIONS
      GO TO 997
  200 IF(NPARS.EQ.0) GO TO 206
      CALL STEST
C     TEST FOR SYMMETRICAL S-TENSOR, IF YES , IORIG = 0
  206 CALL CALCUS
C     CALCULATE U'S
C     PRINT L,T,S RESULTS IN CARTESIAN CRYSTAL FRAME.
      CALL OTHR3
      IF(NONRIG.EQ.0) GO TO 215
      CALL OUTR13
  215 KOUTP = 2
      CALL OUTR1
      CALL EIGVLT
C     DETERMINE EIGENVECTORS AND EIGENVALUES OF T- AND L-TENSOR
      CALL DISCOR
      NCOR = 0
      IF(NONRIG.NE.0.AND.IFREQ.NE.0) CALL NRCOR(NCOR)
C  NCOR GOVERNS PATH THROUGH NRCOR; LATER NRCOR USED TO GET FREQUENCIES
C     FOR OVERALL MOLECULAR LIBRATION (AFTER GET L IN INERTIAL SYSTEM),
C     USING THEN NCOR = 1
      NCOR = 1
  205 CALL CORMAT(NS)
C     CALCULATE CORRELATION MATRIX
  240 IF(NS.LT.0) GO TO 245
      CALL OUTH6
      CALL OTHR6
      KOUTP = 1
C     PRINT UOBS AND UCALC IN CARTESIAN CRYSTAL FRAME
      CALL OUTR4
C     PRINT RMS OF DELTA U'S
  245 CALL OUTR2
      IF(NVIB.NE.0.OR.ICSVIB.NE.0) CALL VIBAMP
C *** rearrange much down to 255, KNT, 20.IV.91
      IF(ISIG.LE.0)  GO TO 235
C     SUMSGU = SQRT(SUM OF INPUT SIGMA U'S SQUARED DIVIDED BY THE NUMBER
C         OF OBSERVATIONS WITH SIGMA U.NE.0, OMITTING THOSE FOR ATOMS
C         WITH WEIGHT 800.)
      ASIGU = FLOAT((NA-N8)*6 - NSIGU)
      SUMSGU = SQRT(SUMSGU/ASIGU)
C     PRINT MEAN STANDARD DEVIATION OF THE U OBSERVED
      CALL OUTR11
  235 CALL UCRYST
      IF(NANG.EQ.0) GO TO 255
C     TRANSFORMATION OF U'S FROM CARTESIAN FRAME TO CRYSTAL FRAME
      IF(NS.EQ.(-2).OR.NS.LT.(-3)) GO TO 255
C     PRINT U'S IN CRYSTAL SYSTEM
  250 CALL OUTH6
      CALL OTHR26
      KOUTP = 2
      CALL OUTR4
      MM=NA+NTOTS
      IF(MM.GT.150) GOTO 255
C     PRINT RMS OF DELTA U'S IN CRYSTAL SYSTEM
      CALL OUTR2
  255 CALL INERT
      CALL ATINT(NCOR)
C ***   AT THIS POINT NCOR IS 1 AND NOW CALLING ATINT FOR GETTING T,L,S
C ***       IN MOLECULAR AXIAL (INERTIAL) SYSTEM
C     RBM PARAMETERS IN THE INERTIAL SYSTEM AND, IF (IFU.NE.0),
C     INTERPRETATION OF THE INDIVIDUAL ATOMS' 'THERMAL' PARAMETERS
      CALL STAS
C     CALCULATE ALTERNATE SYSTEM OF INTERP, DISPLACED AXES SYSTEM
      IF(NPARS.EQ.0) GO TO 260
      IF(IORIG.EQ.0)  GO TO 260
      CALL LFRAME
  260 IF(NS.GT.(-2).OR.NS.EQ.(-3)) CALL ANGLES
  500 IF(NS.GE.0.OR.IOUT.NE.0) CALL LIBCOR
C     CALCULATE LIBRATION CORRECTION FOR ATOMIC COORDINATES IF NS IS NOT
C          NEGATIVE OR IF WANT CORRECTED PARAMETERS OUTPUT
C ***  SAVE IRECAL AS IFU1 (IF IRECAL.NE.0 IN THIS RUN, IFU1 BECOMES SO)
  997 IFU1 = IRECAL
      IF(NS.LT.(-2).OR.NS.GT.0.OR.IRECAL.NE.0)  GO TO 1
C ***  ANOTHER CYCLE WITH SAME PARAMS (IRECAL.NE.0) OR ANOTHER COMPOUND
C ***    FOLLOWS  (NS EITHER POSITIVE OR LESS THAN -2)
  999 CONTINUE
      CLOSE(LI)
      CLOSE(LO)
      CLOSE(LTB)
      STOP
      END
