      SUBROUTINE CNTPAR
C
C     CALLED BY NPAR
C     COUNT NUMBER OF INDEPENDENT OBSERVATIONS AND PARAMETERS
C     NOW USED ONLY FOR POINT GROUPS CORRESPONDING TO MONOCLINIC AND
C         ORTHORHOMBIC SPACE GROUPS (NUMBERS 3, 6, 10, 16, 25, 47)
C
      COMMON /CONT1/ISET,NO,NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,NTO
     1T,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,
     2 IEIG, IMAT,IOUT, IRECAL, IFREQ
      COMMON/IAID1/IAIDX1(1000)
      COMMON/IPAR/NP(80)
      DIMENSION NNP(9)
      EQUIVALENCE (NNP(1),IAIDX1(481))
C
      K = 0
      DO 100 I = 1,6
      IF(NP(I).EQ.0)  GO TO 100
      K = K + 1
      NNP(K) = NP(I)
  100 CONTINUE
      NPULT = K
      N = K - 1
      DO 110 I = 1,N
      NHP = IABS(NNP(I))
      IP1 = I + 1
      DO 105 K1 = IP1,K
      NKP = IABS(NNP(K1))
      IF(NHP.EQ.NKP)  NPULT = NPULT - 1
  105 CONTINUE
  110 CONTINUE
  115 NPARS = 0
      K = 0
      IF(NP(21).NE.0)  GO TO 120
C     COMPENSATE FOR SKIPPING ZERO'S IN THE DIAGONAL
      NPARS = NPARS + 1
  120 DO 130 I = 1,9
      IF(NP(I+12).EQ.0)  GO TO 130
      K = K + 1
      NNP(K) = NP(I+12)
  130 CONTINUE
      N = K - 1
      NPARS = NPARS + N
      IF(NPARS.EQ.0)  GO TO 145
      DO 140 I = 1,N
      NHP = IABS(NNP(I))
      IP1 = I + 1
      DO 150 K1 = IP1,K
      NKP = IABS(NNP(K1))
      IF(NHP.EQ.NKP)  NPARS = NPARS - 1
  150 CONTINUE
  140 CONTINUE
  145 NINPAR = NPULT * 2 + NPARS
      RETURN
      END
