      SUBROUTINE SORT
C
C     SORT ATOMS INTO APPROPRIATE GROUPS, ANALYSIS + INERTIA, ANALYSIS,
C     INERTIA + INTERPRETATION  AND INTERPRETATION ONLY
C ***   MODIFIED 14.IV.87 TO CHECK IF ANY TWO ATOM NAMES ARE SAME
      COMMON/AIDPAR/AX(150,3),AUOBS(150,6),AUCALC(150,6),WU(150,6),
     1  WU1(150,6)
      COMMON/ATPAR/X(150,3),WT(150),MULT(150),UOBS(150,6),SIGU(150,6),UC
     1ALC(150,6),NUORB(150),SIGB(150,6)
      COMMON/AIDCH/NTNAME(150)
      COMMON//AIDX(3000)
      COMMON /CONT1/ISET,NO,NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,NTO
     1T,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,
     2 IEIG,IMAT, IOUT,IRECAL, IFREQ
      COMMON/CORDIN/IRIDE,IMIN,IUNC, IHAT(150), NUNC(20), TUNC(20,3),
     1 TOR(3,3), XCG(3),IHPR
      COMMON/IAID1/IAIDX1(1000)
      COMMON/INOUTN/ NPAGE, KOUTP,  DIS, IAW
      COMMON/INOUTC/ NAME1, ATNAME(150),TISET(20),TITLE,ITBL(29),NAME2
C * * Make common IO assignments.
      COMMON/IOSET/LI,LO,LTB
      DIMENSION AMULT(150),AWT(150),INU(150),IK8(150)
      DIMENSION IK(150), IK1(150), IK2(150), IKH(150), IHT(150)
      EQUIVALENCE (IK8(1),AIDX(351))
C  USING BLANK COMMON AIDX HERE FOR INTEGER VARIABLE BECAUSE IAID1 FULL
C
      CHARACTER*4 NTNAME
      CHARACTER*4 NAME1,ATNAME,TISET,TITLE*80, ITBL*3, NAME2*5
      REAL   MULT
      EQUIVALENCE (IK(1),IAIDX1(801)),(IK1(1),IAIDX1(201))
      EQUIVALENCE (IK2(1),IAIDX1(351)),(IKH(1),IAIDX1(501))
      EQUIVALENCE (INU(1),IAIDX1(651))
      EQUIVALENCE (AMULT(1),AIDX(1)),(AWT(1),AIDX(201))
C
  901 FORMAT(1H ,'INPUT ATOMS ',I3,' AND ',I3,' HAVE SAME NAME, ',A4)
  902 FORMAT(1H ,'AT LEAST THREE PAIRS OF ATOMS WITH SAME NAMES. NO MORE
     1 WILL BE CHECKED.')
  903 FORMAT(1H ,'  MAKE ATOM NAMES UNIQUELY DIFFERENT, SINCE NAMES ARE
     1USED FOR SORTING, FOR IDENTIFYING ESD''S AND ARG AXES, AND FOR'/
     23X,'OTHER SIMILAR PURPOSES.')
      NSA = 0
      II = NTOT - 1
      DO 5 I = 1,II
      JJ = I + 1
      DO 5 J = JJ,NTOT
      IF(ATNAME(I).NE.ATNAME(J)) GO TO 5
      NSA = NSA + 1
      WRITE(LI,901) I, J, ATNAME(I)
      IF(NSA.LT.3) GO TO 5
      WRITE(LO,902)
      WRITE(LO,903)
      STOP
    5 CONTINUE
      IF(NSA.EQ.0) GO TO 7
      WRITE(LO,903)
      STOP
    7 NA = 0
      NA1 = 0
      KH = 0
      K2 = 0
      K1 = 0
      K8 = 0
      K = 0
C     K WILL BE THE NUMBER OF ATOMS WITH POS WTS OTHER THAN 800.
C       AND 999.9; KH IS THE NUMBER OF ATOMS WITH WTS 0.0 (NOTE
C       THIS IS AFTER SUBR XASIGN, SO INPUT WTS OF 0.0 MAY HAVE
C       BEEN CHANGED IF THE ATOM WAS RECOGNIZED CHEMICALLY
C
C     K AND KH COUNT ATOMS FOR ANALYSIS; K8 COUNTS ATOMS WITH WT
C       800., INCLUDED IN NA, BUT SKIPPED IN THE ANALYSIS.  K1
C       COUNTS ATOMS FOR SYSTEM OF INERTIA ONLY (NEG WTS), AND
C       K2 COUNTS ATOMS FOR INTERPRETATION ONLY (WT = 999.9)
      DO 10 I = 1,NTOT
      IF(WT(I).EQ.999.9) GO TO 50
      IF(WT(I).NE.800.0) GO TO 35
      K8 = K8 + 1
      IK8(K8) = I
      NA = NA + 1
      GO TO 9
   35 IF(WT(I)) 70,45,40
   40 K = K + 1
      NA = NA + 1
      IK(K) = I
      GO TO 9
   45 KH = KH + 1
      NA = NA + 1
      IKH(KH) = I
      GO TO 9
   70 K1 = K1 + 1
      NA1 = K1
      IK1(K1) = I
      GO TO 9
   50 K2 = K2 + 1
      IK2(K2) = I
    9 CONTINUE
   10 CONTINUE
      N8 = K8
C ***  SAVE NO. OF ATOMS OF WT 800.0 AS N8 (USED IN MAIN, BETWEEN
C ***    235 AND 255; IN CALCUS NEAR END, AT 60; IN OUTP, IN
C ***    OUTP3 AND OUTP10; IN UCRYST JUST AFTER 10 -- TO FIX AN
C ***    OUTPUT LABEL OR A MEASURE OF AGREEMENT BETWEEN Uobs AND
C ***    Ucalc, SINCE ATOMS OF WT 800.0 HAVE BEEN COUNTED IN NA)
      IF(NA.NE.0)  GO TO 15
      CALL OUTH11
      CALL EXIT
   15 I1 = 1
      I2 = NA
      IKC = 0
      IF(KH.EQ.0)  GO TO 60
      DO 120 I = 1,KH
      IK(K+I) = IKH(I)
  120 CONTINUE
C   FOLLOWING PUTS ATOMS OF WT 800.0 AT END OF GROUP FOR 'ANALYSIS'
   60 IF(K8.EQ.0) GO TO 65
      DO 130 I = 1,K8
      IK(K + KH + I) = IK8(I)
  130 CONTINUE
   65 DO 20 I = I1,I2
      N = IK(I)
      DO 25 K = 1,3
   25 AX(I,K) = X(N,K)
      AWT(I) = WT(N)
      AMULT(I) = MULT(N)
      INU(I) = NUORB(N)
      NTNAME(I) = ATNAME(N)
      IHT(I) = IHAT(N)
      DO 26 K = 1,6
      AUOBS(I,K) = UOBS(N,K)
   26 CONTINUE
   20 CONTINUE
      IKC = IKC + 1
      IF(IKC.EQ.3)  GO TO 3
      IF(NA1.EQ.0)  IKC = IKC + 1
      GO TO (1,2), IKC
    1 I1 = NA + 1
      I2 = NA + NA1
      K = 0
      DO 80 I = I1,I2
      K = K + 1
      IK(I) = IK1(K)
   80 CONTINUE
      GO TO 65
    2 I1 = NA + NA1 + 1
      IF(I1.GT.NTOT)  GO TO 3
      I2 = NTOT
      K = 0
      DO 90 I = I1,I2
      K = K + 1
      IK(I) = IK2(K)
   90 CONTINUE
      GO TO 65
    3 DO 100 I = 1,NTOT
      DO 105 K = 1,3
      X(I,K) = AX(I,K)
  105 CONTINUE
      MULT(I) = AMULT(I)
      NUORB(I) = INU(I)
      WT(I) = AWT(I)
      ATNAME(I) = NTNAME(I)
      IHAT(I) = IHT(I)
      DO 110 K = 1,6
      UOBS(I,K) = AUOBS(I,K)
  110 CONTINUE
  100 CONTINUE
      RETURN
      END
