      SUBROUTINE SYMET
C
C     SYMET PRODUCES ALL THE NECESSARY SYMMETRY OPERATIONS FOR A
C     PARTICULAR POINT GROUP.
C
      COMMON//AIDX(3000)
      COMMON /CONT1/ISET,NO,NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,NTO
     1T,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,
     2 IEIG,IMAT, IOUT,IRECAL, IFREQ
      COMMON/CONT3/ISOLV,NTOTS,CONSLV,SUMW,RWUDI,RMS,RMU,gof,sumsig
      COMMON/IAID1/ IAIDX1(1000)
      COMMON/INOUTN/ NPAGE, KOUTP,  DIS, IAW
      COMMON/INOUTC/ NAME1, ATNAME(150),TISET(20),TITLE,ITBL(29),NAME2
      COMMON/IPAR/NP(80)
      COMMON/SYM/SYMOP(23,3,3),TMAT(3,3),RTMAT(3,3),EPSIJK(3,3,3),
     1 SYML(3)
C
C * * Make common IO assignments.
      COMMON/IOSET/LI,LO,LTB
      DIMENSION IAID(50)
      DIMENSION NS1(1),NS2(2),NS3(2),NS6(2),NS10(4),NS16(4),NS25(4)
      DIMENSION NS47(8),NS75(4),NS81(4),NS83(8),NS89(8),NS99(8),NS111(8)
      DIMENSION NS123(16),NS143(3),NS146(3),NS147(6),NS148(6),NS149(6)
      DIMENSION NS150(6),NS155(6),NS156(6),NS157(6),NS160(6),NS162(12)
      DIMENSION NS164(12),NS166(12),NS168(6),NS174(6),NS175(12)
      DIMENSION NS177(12),NS183(12),NS187(12),NS189(12),NS191(24)
      DIMENSION NS195(12),NS200(24),NS207(24),NS215(24),NS221(48)
      DIMENSION NPS1(21), NPS6(5), NPS7(4), NPS8(12), NPS9(12),NPS10(9)
      DIMENSION NPS11(9), NPS12(9)
      DIMENSION TNAME1(41),TNAME2(41)
C
      EQUIVALENCE(IATEX,IAIDX1(500))
      EQUIVALENCE (IAIDX1(499),NHA)
      EQUIVALENCE(IAIDX1(351),IAID(1))
      CHARACTER*4 NAME1,ATNAME,TISET,TITLE*80, ITBL*3, TNAME1
      CHARACTER*5 NAME2, TNAME2
C
C        THE FOLLOWING DATA STATEMENTS ARE VALID ONLY FOR CDC VERSIONS
C          OF THMB.  THEY HAVE BEEN HERE CONVERTED TO COMMENTS BUT HAVE
C          BEEN LEFT IN FOR CHECKING OR POSSIBLE RECONVERSION.
C          (THIS APPLIES TO SYMOP AND EPSIJK ONLY. THEY ARE NOW INITIAL-
C          IZED IN A BLOCK DATA SUBPROGRAM.)
C
C     DATA (((EPSIJK(I,J,K),K=1,3),J=1,3),I=1,3)/0.,0.,0.,0.,0.,1.,0.,-1
C    1.,0.,0.,0.,-1.,0.,0.,0.,1.,0.,0.,0.,1.,0.,-1.,0.,0.,0.,0.,0./
C     DATA ((SYMOP( 1,I,K),K=1,3),I=1,3)/1.,0.,0.,0.,1.,0.,0.,0.,1./
C     DATA ((SYMOP( 2,I,K),K=1,3),I=1,3)/1.,0.,0.,0.,-1.,0.,0.,0.,-1./
C     DATA ((SYMOP( 3,I,K),K=1,3),I=1,3)/-1.,0.,0.,0.,1.,0.,0.,0.,-1./
C     DATA ((SYMOP( 4,I,K),K=1,3),I=1,3)/-1.,0.,0.,0.,-1.,0.,0.,0.,1./
C     DATA ((SYMOP( 5,I,K),K=1,3),I=1,3)/0.,1.,0.,1.,0.,0.,0.,0.,-1./
C     DATA ((SYMOP( 6,I,K),K=1,3),I=1,3)/0.,-1.,0.,-1.,0.,0.,0.,0.,-1./
C     DATA ((SYMOP( 7,I,K),K=1,3),I=1,3)/-1.,1.,0.,0.,1.,0.,0.,0.,-1./
C     DATA ((SYMOP( 8,I,K),K=1,3),I=1,3)/1.,0.,0.,1.,-1.,0.,0.,0.,-1./
C     DATA ((SYMOP( 9,I,K),K=1,3),I=1,3)/1.,-1.,0.,0.,-1.,0.,0.,0.,-1./
C     DATA ((SYMOP(10,I,K),K=1,3),I=1,3)/-1.,0.,0.,-1.,1.,0.,0.,0.,-1./
C     DATA ((SYMOP(11,I,K),K=1,3),I=1,3)/0.,-1.,0.,1.,0.,0.,0.,0.,1./
C     DATA ((SYMOP(12,I,K),K=1,3),I=1,3)/0.,1.,0.,-1.,0.,0.,0.,0.,1./
C     DATA ((SYMOP(13,I,K),K=1,3),I=1,3)/0.,-1.,0.,1.,-1.,0.,0.,0.,1./
C     DATA ((SYMOP(14,I,K),K=1,3),I=1,3)/-1.,1.,0.,-1.,0.,0.,0.,0.,1./
C     DATA ((SYMOP(15,I,K),K=1,3),I=1,3)/1.,-1.,0.,1.,0.,0.,0.,0.,1./
C     DATA ((SYMOP(16,I,K),K=1,3),I=1,3)/0.,1.,0.,-1.,1.,0.,0.,0.,1./
C     DATA ((SYMOP(17,I,K),K=1,3),I=1,3)/-1.,0.,0.,0.,-1.,0.,0.,0.,-1./
C     DATA ((SYMOP(18,I,K),K=1,3),I=1,3)/0.,0.,1.,1.,0.,0.,0.,1.,0./
C     DATA ((SYMOP(19,I,K),K=1,3),I=1,3)/0.,1.,0.,0.,0.,1.,1.,0.,0./
C     DATA ((SYMOP(20,I,K),K=1,3),I=1,3)/0.,-0.707106781,-0.707106781,0.
C    1,0.707106781,-0.707106781,1.,0.,0./
C     DATA ((SYMOP(21,I,K),K=1,3),I=1,3)/0.,0.,1.,-0.707106781,0.7071067
C    181,0.,-0.707106781,-0.707106781,0./
C     DATA ((SYMOP(22,I,K),K=1,3),I=1,3)/0.,0.,-1.,-1.,0.,0.,0.,-1.,0./
C     DATA ((SYMOP(23,I,K),K=1,3),I=1,3)/0.,-1.,0.,0.,0.,-1.,-1.,0.,0./
C
      DATA NS1   /010101/, NS2          /010101,170101/
      DATA  NS3          /010101,010401/, NS6          /010101,170401/
      DATA  NS10          /010101,170101,010401,170401/
      DATA  NS16          /010101,010401,010201,010301/
      DATA  NS25          /010101,010401,170201,170301/
      DATA  NS47          /010101,170101,010201,010301,010401,170201,170
     1301,170401/
      DATA  NS75          /010101,010401,011101,011201/
      DATA  NS81          /010101,010401,171101,171201/
      DATA  NS83          /010101,010401,170401,170101,011101,011201,171
     1101,171201/
      DATA  NS89          /010101,010401,010201,010301,011101,011201,010
     1501,010601/
      DATA  NS99          /010101,010401,011101,011201,170201,170301,170
     1601,170501/
      DATA  NS111          /010101,010401,010301,010201,171101,171201,17
     10601,170501/
      DATA  NS123           /010101,010401,170401,170101,170201,170301,0
     110201,010301,011101,011201,171201,171101,170601,170501,010501,0106
     201/
      DATA  NS143          /010101,011301,011401/
      DATA  NS146          /010101,011801,011901/
      DATA  NS147          /010101,011301,011401,170101,171301,171401/
      DATA  NS148          /010101,011801,011901,170101,171801,171901/
      DATA  NS149          /010101,011301,011401,010601,010701,010801/
      DATA  NS150          /010101,011301,011401,010501,010901,011001/
      DATA  NS155          /010101,011801,011901,010601,061901,061801/
      DATA  NS156          /010101,011301,011401,170501,171001,170901/
      DATA  NS157          /010101,011301,011401,170601,170801,170701/
      DATA  NS160          /010101,011801,011901,170601,170619,170618/
      DATA  NS162           /010101,011301,011401,170101,171301,171401,1
     170601,170801,170701,010601,010801,010701/
      DATA  NS164           /010101,011301,011401,170101,171301,171401,1
     170501,171001,170901,010501,011001,010901/
      DATA  NS166           /010101,011801,011901,170601,170619,170618,1
     170101,171801,171901,010601,010619,010618/
      DATA  NS168          /010101,011301,011401,010401,011501,011601/
      DATA  NS174          /010101,011301,011401,170401,171501,171601/
      DATA  NS175           /010101,011301,011401,170101,171301,171401,0
     110401,011501,011601,170401,171501,171601/
      DATA  NS177           /010101,011301,011401,010401,011501,011601,0
     110501,011001,010901,010601,010801,010701/
      DATA  NS183           /010101,011301,011401,010401,011601,011501,1
     170601,170701,170801,170501,171001,170901/
      DATA  NS187           /010101,011301,011401,170401,171601,171501,1
     170501,171001,170901,010601,010801,010701/
      DATA  NS189           /010101,011301,011401,170401,171601,171501,1
     170601,170801,170701,010501,011001,010901/
      DATA  NS191           /010101,011301,011401,170601,170801,170701,0
     110401,011601,011501,170501,171001,170901,170401,171501,171601,0105
     201,011001,010901,170101,171301,171401,010601,010801,010701/
      DATA  NS195           /010101,011801,011901,010201,021801,021901,0
     110301,031801,031901,010401,041801,041901/
      DATA  NS200           /010101,011801,011901,170101,171801,171901,0
     110201,021801,021901,170201,170218,170219,010301,031801,031901,1703
     201,170318,170319,010401,041801,041901,170401,170418,170419/
      DATA  NS207           /010101,011801,011901,180619,010601,190618,0
     110201,021801,021901,180519,011101,180501,010301,031801,031901,1811
     219,011201,190518,010401,041801,041901,051801,010501,191118/
      DATA  NS215           /010101,011801,011901,170618,170601,230618,0
     110201,021801,021901,220519,171101,171805,010301,031801,031901,2211
     219,171201,230518,010401,041801,041901,170518,170501,231118/
      DATA  NS221           /010101,011801,011901,170618,170601,230618,0
     110201,021801,021901,220519,171101,171805,010301,031801,031901,2211
     219,171201,230518,010401,041801,041901,170518,170501,231118,170101,
     3171801,171901,010618,010601,190618,170201,170218,170219,180519,011
     4101,180105,170301,170318,170319,181119,011201,190518,170401,170418
     5,170419,010518,010501,191118/
C
      DATA  NPS1           /1,0,0,1,0,6,7,0,0,7,0,12,13,14,0,14,13,0,0,0
     1,0/
      DATA NPS6          /0,14,0,-14,0/
      DATA  NPS7          /0,0,0,-13/
      DATA  NPS8           /1,2,2,1,2,1,7,8,8,7,8,7/
      DATA  NPS9           /1,0,0,1,0,1,7,0,0,7,0,7/
      DATA  NPS10          /0,14,15,15,0,14,14,15,0/
      DATA  NPS11          /0,14,14,14,0,14,14,14,0/
      DATA  NPS12          /0,14,-14,-14,0,14,14,-14,0/
      DATA TNAME1/'C1','CI','C2','CS','C2H','D2','C2V','D2H','C4','S4',
     1 'C4H','D4','C4V','D2D','D4H','C3','C3','C3I','C3I','D3','D3',
     2'D3','C3V','C3V','C3V','D3D','D3D','D3D','C6','C3H','C6H','D6',
     3 'C6V','D3H','D3H','D6H','T','TH','O','TD','OH'/
      DATA TNAME2/'1','-1','2','M','2/M','222','MM2','MMM','4','-4',
     1 '4/M','422','MM4','-42M','4/MMM','3','CUBIC','-3','CUBIC','312',
     2 '321','CUBIC','3M1','31M','CUBIC','-31M','-3M1','CUBIC','6','-6',
     3 '6/M','622','6MM','-6M2','-62M','6/MMM','23','M3','432','-43M',
     4 'M3M'/
C
C     IF ISET.GT.5 TMAT AND RTMAT IS READ AS INPUT
      IF(ISET.GT.5)  GO TO 1000
      GO TO (300,310,320,330,340), ISET
C     ISET = 1,  Z-AXIS = PRINCIPAL AXIS
  300 DO 305 I=1,3
      DO 305 K=1,3
      TMAT(I,K) = SYMOP(1,I,K)
      RTMAT(I,K) = SYMOP(1,I,K)
  305 CONTINUE
      GO TO 1000
C     ISET = 2   X-AXIS = PRINCIPAL AXIS
  310 DO 315 I=1,3
      DO 315 K=1,3
      TMAT(I,K) = SYMOP(18,I,K)
      RTMAT(I,K) = SYMOP(19,I,K)
  315 CONTINUE
      GO TO 1000
C     ISET = 3   Y-AXIS = PRINCIPAL AXIS
  320 DO 325 I=1,3
      DO 325 K=1,3
      TMAT(I,K) = SYMOP(19,I,K)
      RTMAT(I,K) = SYMOP(18,I,K)
  325 CONTINUE
      GO TO 1000
C     ISET = 4   XY-DIAGONAL = PRINCIPAL AXIS
  330 DO 335 I=1,3
      DO 335 K=1,3
      TMAT(I,K) = SYMOP(20,I,K)
      RTMAT(I,K) = SYMOP(21,I,K)
  335 CONTINUE
C     ISET = 5  XYZ-DIAGONAL = PRINCIPAL AXIS FOR GROUPS IN CUBIC
C        CRYSTALS WITH POINT GROUPS SPECIFIED AS 146 (C3), 148 (C3I),
C        155 (D3), 160 (C3V), OR 166 (D3D)
  340 DO 345 I = 1,3
      DO 345 K = 1,3
      TMAT(I,K) = SYMOP(1,I,K)
      RTMAT(I,K) = SYMOP(1,I,K)
  345 CONTINUE
 1000 IF(NO.LE. 47)  GO TO  400
C      THE SYMMETRY CONSTRAINTS WILL BE PRESET FOR ALL POINT GROUPS
C        WITH HIGHER THAN ORTHORHOMBIC SYMMETRY
      DO 350 I = 1,21
  350 NP(I) = NPS1(I)
      IF(NO.LE.123)  GO TO  410
      IF(NO.LE.160)  GO TO  420
      IF(NO.LE.183)  GO TO  430
      IF(NO.EQ.187)  GO TO 187
      IF(NO.EQ.189)  GO TO 189
      IF(NO.EQ.191)  GO TO 191
      IF(NO.GE.195) GO TO 1965
C     ALL GROUPS WITH CUBIC SYMMETRY HAVE CERTAIN COMMON FEATURES
 1960 IF(NO.EQ.195)  GO TO 195
      IF(NO.EQ.200)  GO TO 200
      IF(NO.EQ.207)  GO TO 207
      IF(NO.EQ.215)  GO TO 215
      IF(NO.EQ.221)  GO TO 221
      GO TO 999
 1965 NPARS = 0
      NPULT = 1
      DO 1966 I = 1,12
 1966 NP(I) = NPS9(I)
      GO TO 1960
  187 NAME1 = TNAME1(34)
      NAME2 = TNAME2(34)
      NMULT = 12
      NPARS = 0
      NPULT = 2
      DO 1870 K = 1,NMULT
 1870 IAID(K) = NS187(K)
      DO 1871 K = 13,17
 1871 NP(K) = 0
      GO TO 3000
  189 NAME1 = TNAME1(35)
      NAME2 = TNAME2(35)
      NMULT = 12
      NPARS = 0
      NPULT = 2
      DO 1890 K = 1,NMULT
 1890 IAID(K) = NS189(K)
      DO 1891 K = 13,17
 1891 NP(K) = 0
      GO TO 3000
  191 NAME1 = TNAME1(36)
      NAME2 = TNAME2(36)
      NMULT = 24
      NPARS = 0
      NPULT = 2
      DO 1910 K = 1,NMULT
 1910 IAID(K) = NS191(K)
      DO 1911 K = 13,17
 1911 NP(K) = 0
      GO TO 3000
  195 NAME1 = TNAME1(37)
      NAME2 = TNAME2(37)
      NMULT = 12
      DO 1950 K = 1,NMULT
 1950 IAID(K) = NS195(K)
      GO TO 3000
  200 NAME1 = TNAME1(38)
      NAME2 = TNAME2(38)
      NMULT = 24
      DO 2000 K = 1,NMULT
 2000 IAID(K) = NS200(K)
      GO TO 3000
  207 NAME1 = TNAME1(39)
      NAME2 = TNAME2(39)
      NMULT = 24
      DO 2070 K = 1,NMULT
 2070 IAID(K) = NS207(K)
      GO TO 3000
  215 NAME1 = TNAME1(40)
      NAME2 = TNAME2(40)
      NMULT = 24
      DO 2150 K = 1,NMULT
 2150 IAID(K) = NS215(K)
      GO TO 3000
  221 NAME1 = TNAME1(41)
      NAME2 = TNAME2(41)
      NMULT = 48
      DO 2210 K = 1,NMULT
 2210 IAID(K) = NS221(K)
      GO TO 3000
  400 IF(NO.EQ.1)  GO TO 1
      IF(NO.EQ.2)  GO TO 2
      IF(NO.EQ.3)  GO TO 3
      IF(NO.EQ.6)  GO TO 6
      IF(NO.EQ.10)  GO TO 10
      IF(NO.EQ.16)  GO TO 16
      IF(NO.EQ.25)  GO TO 25
      IF(NO.EQ.47)  GO TO 47
      GO TO 999
    1 NAME1 = TNAME1(1)
      NAME2 = TNAME2(1)
      NMULT = 1
      DO 1001 K = 1,NMULT
 1001 IAID(K) = NS1(K)
      GO TO 3000
    2 NAME1 = TNAME1(2)
      NAME2 = TNAME2(2)
      NMULT = 2
      DO 1002 K = 1,NMULT
 1002 IAID(K) = NS2(K)
      GO TO 3000
    3 NAME1 = TNAME1(3)
      NAME2 = TNAME2(3)
      NMULT = 2
      DO 1003 K = 1,NMULT
 1003 IAID(K) = NS3(K)
      GO TO 3000
    6 NAME1 = TNAME1(4)
      NAME2 = TNAME2(4)
      NMULT = 2
      DO 1006 K = 1,NMULT
 1006 IAID(K) = NS6(K)
      GO TO 3000
   10 NAME1 = TNAME1(5)
      NAME2 = TNAME2(5)
      NMULT = 4
      DO 1010 K = 1,NMULT
 1010 IAID(K) = NS10(K)
      GO TO 3000
   16 NAME1 = TNAME1(6)
      NAME2 = TNAME2(6)
      NMULT = 4
      DO 1016 K = 1,NMULT
 1016 IAID(K) = NS16(K)
      GO TO 3000
   25 NAME1 = TNAME1(7)
      NAME2 = TNAME2(7)
      NMULT = 4
      DO 1025 K = 1,NMULT
 1025 IAID(K) = NS25(K)
      GO TO 3000
   47 NAME1 = TNAME1(8)
      NAME2 = TNAME2(8)
      NMULT = 8
      DO 1047 K = 1,NMULT
 1047 IAID(K) = NS47(K)
      GO TO 3000
  410 IF(NO.EQ.75)  GO TO 75
      IF(NO.EQ.81)  GO TO 81
      IF(NO.EQ.83)  GO TO 83
      IF(NO.EQ.89)  GO TO 89
      IF(NO.EQ.99)  GO TO 99
      IF(NO.EQ.111)  GO TO 111
      IF(NO.EQ.123)  GO TO 123
      GO TO 999
   75 NAME1 = TNAME1(9)
      NAME2 = TNAME2(9)
      NMULT = 4
      NPARS = 2
      NPULT = 2
      DO 1075 K = 1,NMULT
 1075 IAID(K) = NS75(K)
      NP(16) = -14
      NP(21) = 21
      GO TO 3000
   81 NAME1 = TNAME1(10)
      NAME2 = TNAME2(10)
      NMULT = 4
      NPARS = 2
      NPULT = 2
      DO 1081 K = 1,NMULT
 1081 IAID(K) = NS81(K)
      NP(17) = -13
      GO TO 3000
   83 NAME1 = TNAME1(11)
      NAME2 = TNAME2(11)
      NMULT = 8
      NPARS = 0
      NPULT = 2
      DO 1083 K = 1,NMULT
 1083 IAID(K) = NS83(K)
      DO 1084 I = 13,17
 1084 NP(I) = 0
      GO TO 3000
   89 NAME1 = TNAME1(12)
      NAME2 = TNAME2(12)
      NMULT = 8
      NPARS = 1
      NPULT = 2
      DO 1089 K = 1,NMULT
 1089 IAID(K) = NS89(K)
      DO 1090 I = 14,16
 1090 NP(I) = 0
      NP(21) = 21
      GO TO 3000
   99 NAME1 = TNAME1(13)
      NAME2 = TNAME2(13)
      NMULT = 8
      NPARS = 1
      NPULT = 2
      DO 1099 K = 1,NMULT
 1099 IAID(K) = NS99(K)
      DO 1101 I = 13,17
      K = I - 12
 1101 NP(I) = NPS6(K)
      GO TO 3000
  111 NAME1 = TNAME1(14)
      NAME2 = TNAME2(14)
      NMULT = 8
      NPARS = 1
      NPULT = 2
      DO 1111 K = 1,NMULT
 1111 IAID(K) = NS111(K)
      DO 1112 I = 14,17
      K = I - 13
 1112 NP(I) = NPS7(K)
      GO TO 3000
  123 NAME1 = TNAME1(15)
      NAME2 = TNAME2(15)
      NMULT = 16
      NPARS = 0
      NPULT = 2
      DO 1123 K = 1,NMULT
 1123 IAID(K) = NS123(K)
      DO 1124 I = 13,17
 1124 NP(I) = 0
      GO TO 3000
  420 IF(NO.EQ.143)  GO TO 143
      IF(NO.EQ.146)  GO TO 146
      IF(NO.EQ.147)  GO TO 147
      IF(NO.EQ.148)  GO TO 148
      IF(NO.EQ.149)  GO TO 149
      IF(NO.EQ.150)  GO TO 150
      IF(NO.EQ.155)  GO TO 155
      IF(NO.EQ.156)  GO TO 156
      IF(NO.EQ.157)  GO TO 157
      IF(NO.EQ.160)  GO TO 160
      GO TO 999
  143 NAME1 = TNAME1(16)
      NAME2 = TNAME2(16)
      NMULT = 3
      NPARS = 2
      NPULT = 2
      DO 1143 K = 1,NMULT
 1143 IAID(K) = NS143(K)
      NP(16) = -14
      NP(21) = 21
      GO TO 3000
  146 NAME1 = TNAME1(17)
      NAME2 = TNAME2(17)
      NMULT = 3
      NPARS = 2
      NPULT = 2
      DO 1146 K = 1,NMULT
 1146 IAID(K) = NS146(K)
      DO 1128 I = 1,12
 1128 NP(I) = NPS8(I)
      DO 1129 I = 13,21
      K = I - 12
 1129 NP(I) = NPS10(K)
      GO TO 3000
  147 NAME1 = TNAME1(18)
      NAME2 = TNAME2(18)
      NMULT = 6
      NPARS = 0
      NPULT = 2
      DO 1147 K = 1,NMULT
 1147 IAID(K) = NS147(K)
      DO 1130 I = 13,17
 1130 NP(I) = 0
      GO TO 3000
  148 NAME1 = TNAME1(19)
      NAME2 = TNAME2(19)
      NMULT = 6
      NPARS = 0
      NPULT = 2
      DO 1148 K = 1,NMULT
 1148 IAID(K) = NS148(K)
      DO 1131 I = 1,12
 1131 NP(I) = NPS8(I)
      DO 1132 I = 13,17
 1132 NP(I) = 0
      GO TO 3000
  149 NAME1 = TNAME1(20)
      NAME2 = TNAME2(20)
      NMULT = 6
      NPARS = 1
      NPULT = 2
      DO 1149 K = 1,NMULT
 1149 IAID(K) = NS149(K)
      DO 1133 I = 14,16
 1133 NP(I) = 0
      NP(21) = 21
      GO TO 3000
  150 NAME1 = TNAME1(21)
      NAME2 = TNAME2(21)
      NMULT = 6
      NPARS = 1
      NPULT = 2
      DO 1150 K = 1,NMULT
 1150 IAID(K) = NS150(K)
      DO 1134 I = 14,16
 1134 NP(I) = 0
      NP(21) = 21
      GO TO 3000
  155 NAME1 = TNAME1(22)
      NAME2 = TNAME2(22)
      NMULT = 6
      NPULT = 2
      NPARS = 1
      DO 1155 K = 1,NMULT
 1155 IAID(K) = NS155(K)
      DO 1135 I = 1,12
 1135 NP(I) = NPS8(I)
      DO 1136 I = 13,21
      K = I - 12
 1136 NP(I) = NPS11(K)
      GO TO 3000
  156 NAME1 = TNAME1(23)
      NAME2 = TNAME2(23)
      NMULT = 6
      NPARS = 1
      NPULT = 2
      DO 1156 K = 1,NMULT
 1156 IAID(K) = NS156(K)
      DO 1137 I = 13,17
      K = I - 12
 1137 NP(I) = NPS6(K)
      GO TO 3000
  157 NAME1 = TNAME1(24)
      NAME2 = TNAME2(24)
      NMULT = 6
      NPARS = 1
      NPULT = 2
      DO 1157 K = 1,NMULT
 1157 IAID(K) = NS157(K)
      DO 1138 I = 13,17
      K = I - 12
 1138 NP(I) = NPS6(K)
      GO TO 3000
  160 NAME1 = TNAME1(25)
      NAME2 = TNAME2(25)
      NMULT = 6
      NPARS = 1
      NPULT = 2
      DO 1160 K = 1,NMULT
 1160 IAID(K) = NS160(K)
      DO 1139 I = 1,12
 1139 NP(I) = NPS8(I)
      DO 1140 I = 13,21
      K = I - 12
 1140 NP(I) = NPS12(K)
      GO TO 3000
  430 IF(NO.EQ.162)  GO TO 162
      IF(NO.EQ.164)  GO TO 164
      IF(NO.EQ.166)  GO TO 166
      IF(NO.EQ.168)  GO TO 168
      IF(NO.EQ.174)  GO TO 174
      IF(NO.EQ.175)  GO TO 175
      IF(NO.EQ.177)  GO TO 177
      IF(NO.EQ.183)  GO TO 183
      GO TO 999
  162 NAME1 = TNAME1(26)
      NAME2 = TNAME2(26)
      NMULT = 12
      NPARS = 0
      NPULT = 2
      DO 1162 K = 1,NMULT
 1162 IAID(K) = NS162(K)
      DO 1163 I = 13,17
 1163 NP(I) = 0
      GO TO 3000
  164 NAME1 = TNAME1(27)
      NAME2 = TNAME2(27)
      NMULT = 12
      NPARS = 0
      NPULT = 2
      DO 1164 K = 1,NMULT
 1164 IAID(K) = NS164(K)
      DO 1165 I = 13,17
 1165 NP(I) = 0
      GO TO 3000
  166 NAME1 = TNAME1(28)
      NAME2 = TNAME2(28)
      NMULT = 12
      NPARS = 0
      NPULT = 2
      DO 1166 K = 1,NMULT
 1166 IAID(K) = NS166(K)
      DO 1167 I = 1,12
 1167 NP(I) = NPS8(I)
      DO 1169 I = 13,17
 1169 NP(I) = 0
      GO TO 3000
  168 NAME1 = TNAME1(29)
      NAME2 = TNAME2(29)
      NMULT = 6
      NPARS = 2
      NPULT = 2
      DO 1168 K = 1,NMULT
 1168 IAID(K) = NS168(K)
      NP(16) = -14
      NP(21) = 21
      GO TO 3000
  174 NAME1 = TNAME1(30)
      NAME2 = TNAME2(30)
      NMULT = 6
      NPARS = 0
      NPULT = 2
      DO 1174 K = 1,NMULT
 1174 IAID(K) = NS174(K)
      DO 1170 I = 13,17
 1170 NP(I) = 0
      GO TO 3000
  175 NAME1 = TNAME1(31)
      NAME2 = TNAME2(31)
      NMULT = 12
      NPARS = 0
      NPULT = 2
      DO 1175 K = 1,NMULT
 1175 IAID(K) = NS175(K)
      DO 1171 I = 13,17
 1171 NP(I) = 0
      GO TO 3000
  177 NAME1 = TNAME1(32)
      NAME2 = TNAME2(32)
      NMULT = 12
      NPARS = 1
      NPULT = 2
      DO 1177 K = 1,NMULT
 1177 IAID(K) = NS177(K)
      DO 1178 I = 14,16
 1178 NP(I) = 0
      NP(21) = 21
      GO TO 3000
  183 NAME1 = TNAME1(33)
      NAME2 = TNAME2(33)
      NMULT = 12
      NPARS = 1
      NPULT = 2
      DO 1183 K = 1,NMULT
 1183 IAID(K) = NS183(K)
      DO 1184 I = 13,17
      K = I - 12
 1184 NP(I) = NPS6(K)
 3000 CONTINUE
      IF(NS.GE.-1 .OR. NS.EQ.-3) CALL OUTP5
C     PRINT NAME1,NAME2,NMULT
      NHA = NA + NA1
      NHT = NTOT + NHA*(NMULT - 1)
      IF(NHT.GT.150)  GO TO 998
C     ONLY A TOTAL OF 150 ATOMS, UNIQUE AND GENERATED, ALLOWED
      CALL SYMPOS
      RETURN
  998 NTOT = NHT
      CALL OUTH13
      GO TO 997
  999 CALL OUTH5
  997 IATEX = -1
      RETURN
      END
