      SUBROUTINE SYMPOS
C *****EFM MARCH 1991 CALCULATE WTS AND MULTS FOR SYMMETRY-EQUIVALENT
C *****ATOMS
C     CALCULATE NMULT TRANSFORMATION MATRICES AIDS(I,J,K) AND COMPLETE
C        SET OF SYMMETRY-RELATED ATOMIC POSITIONS FOR CALCULATION OF
C        INERTIAL TENSOR AND SYM-RELATED POSITIONS, U'S, AND SIGU'S FOR
C        NORMAL EQUATIONS
C
C ***  19.IV.87  ADDED EXTENSION OF ATNAME TO INCLUDE ALL ATOMS
C ***     AND MM = 2 FOR 2nd CALL OF SGTRAN (FOR 2nd AND FURTHER POSNS)
C
      COMMON/AIDPAR/AX(150,3),AUOBS(150,6),AUCALC(150,6),WU(150,6),
     1  WU1(150,6)
      COMMON/ATPAR/X(150,3),WT(150),MULT(150),UOBS(150,6),SIGU(150,6),UC
     1ALC(150,6),NUORB(150),SIGB(150,6)
      COMMON//AIDX(3000)
      COMMON/CELLP/CD(12),RCD(12),VOL,VST,G(3,3)
      COMMON /CONT1/ISET,NO,NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,NTO
     1T,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,
     2 IEIG,IMAT, IOUT,IRECAL, IFREQ
      COMMON /CONT2/ NP1,NNP1,IORIG,IWU,INOPAR
      COMMON/CONT3/ISOLV,NTOTS,CONSLV,SUMW,RWUDI,RMS,RMU,gof,sumsig
      COMMON/INOUTC/ NAME1,ATNAME(150),TISET(20),TITLE,ITBL(29),NAME2
      COMMON/IAID1/ IAIDX1(1000)
      COMMON/SYM/SYMOP(23,3,3),TMAT(3,3),RTMAT(3,3),EPSIJK(3,3,3),
     1 SYML(3)
C
C * * Make common IO assignments.
      COMMON/IOSET/LI,LO,LTB
      DIMENSION AIDS(48,3,3),DET(48),AIDH(3,3)
      DIMENSION AXX(150,3), AXWT(150), WTT(150)
      DIMENSION AIDH1(3,3),IAID(50)
      DIMENSION VH(3),VH1(3),AU(3,3),AUS(3,3),TUS(3,3),TTUS(3,3)
C
      EQUIVALENCE (TUS(1,1),AIDX(2600)),(TTUS(1,1),AIDX(2610))
      EQUIVALENCE (AU(1,1),AIDX(2620)),(AUS(1,1),AIDX(2630))
      EQUIVALENCE (VH(1),AIDX(2640)),(VH1(1),AIDX(2645))
      EQUIVALENCE (IAIDX1(499),NHA)
      EQUIVALENCE (AXX(1,1),AIDX(1)),(AXWT(1),AIDX(601))
      EQUIVALENCE(IAIDX1(351),IAID(1))
      EQUIVALENCE(IAIDX1(498),M1), (WTT(1),AIDX(451))
      EQUIVALENCE(IAIDX1(497),M2),(IAIDX1(496),M3)
      EQUIVALENCE (AIDH(1,1),AIDX(2901)),(AIDH1(1,1),AIDX(2911))
      EQUIVALENCE (AIDS(1,1,1),AIDX(2001)),(DET(1),AIDX(2501))
C
      CHARACTER*4 NAME1, ATNAME, TISET, TITLE*80, ITBL*3, NAME2*5
       REAL MULT
C
      IF(ISYM.NE.0) GO TO 101
C      SET VALUE OF SYML(I) AS 0.0 IF ORIGIN LIES ON ALL SYM ELEMENTS
      DO 100 I = 1,3
      SYML(I) = 0.0
  100 CONTINUE
  101 CONTINUE
      DO 102 I = 1,NTOT
  102 WTT(I) = WT(I)
      ICOUNT = 0
      DO 3010  I=1,NMULT
      DET(I) = 1.
C     M1 = ADDRESS SYMOP 1, M2 = ADDRESS SYMOP 2, M3 = ADDRESS SYMOP 3
      M1 = IAID(I)/10000
      IF(M1.EQ.17)  GO TO 3006
      IF(M1.EQ.22)  GO TO 3006
      IF(M1.EQ.23)  GO TO 3006
      GO TO 3005
 3006 DET(I) = -1.
 3005 M2 = (IAID(I) - M1*10000)/100
      M3 = (IAID(I) - M1*10000 - M2*100)
      CALL TRIPMA(M1,M2,M3)
C     RESULTS OF TRIPMA IN AIDH(3,3)
      CALL TRIPLE(TMAT,AIDH,RTMAT,AIDH1)
      DO 3015 I1=1,3
      DO 3015 I2=1,3
 3015 AIDS(I,I1,I2) = AIDH1(I1,I2)
      DO 3011 J = 1,NHA
C  NHA (FROM END OF SYMET) = NO. OF UNIQUE ATOMS FOR INERTIAL SYSTEM,
C    WHICH INCLUDES ALL WITH WT OTHER THAN 999.9. THOSE WITH WT = 800.0
C    WILL CONTRIBUTE NOTHING BUT ARE INCLUDED AT THIS POINT
      ICOUNT = ICOUNT + 1
      CALL VECH(X,J,VH)
C        MOVE MOLECULE SO SYMMETRY ELEMENT IS THROUGH ORIGIN SO THAT THE
C          SYMMETRY OPERATIONS STORED IN SYMET ARE APPLICABLE
      DO 3020 K = 1,3
      VH(K) = VH(K) - SYML(K)
 3020 CONTINUE
      CALL MATVEC(AIDH1,VH,VH1)
      DO 3030 K = 1,3
      AXX(ICOUNT,K) = VH1(K) + SYML(K)
 3030 CONTINUE
C ***  AXX, CREATED HERE AND USED IN INERT, ARE AT THIS POINT THE
C ***    CRYSTAL SYSTEM POSNS REL TO ORIGINAL ORIGIN, FOR ALL ATOMS IN
C ***    THE INERTIAL SYSTEM, UNIQUE AND SYMMETRY-GENERATED
      AXWT(ICOUNT) = WT(J)*MULT(J)
 3011 CONTINUE
 3010 CONTINUE
C     CREATE ADDITIONAL SET OF X,UOBS,SIGU FOR THE NA*(NMULT-1) ATOMS
C        BEYOND THE FIRST NTOT ATOMS
      IF(NO.EQ.1) RETURN
C     NO ADDITIONAL SYMMETRY-RELATED ATOMS FOR C1
      NTOTS = NTOT
      DO 20 I = 2,NMULT
      DO 25 I1 = 1,3
      DO 25 J1 = 1,3
      TUS(I1,J1) = AIDS(I,I1,J1)
C     TUS IS TRANSFORMATION MATRIX FOR UOBS
   25 CONTINUE
      CALL TRAMA(TUS,TTUS)
C     TTUS = TRANSPOSE OF TUS
      DO 30 J = 1,NA
      NTOTS = NTOTS + 1
      WTT(NTOTS) = WT(J)
C ***** EFM 3/91
      WT(NTOTS) = WT(J)
      mult(ntots) = mult(j)
C  THIS GENERATES WTS FOR THE NA*(NMULT-1) ATOMS GENERATED BY SYMMETRY;
C     THOSE FOR THE FIRST NTOT WERE INPUT AND EQUATED TO WTT ABOVE.
      ATNAME(NTOTS) = ATNAME(J)
      CALL VECH(X,J,VH)
      DO 40  K = 1,3
      VH(K) = VH(K) - SYML(K)
   40 CONTINUE
      CALL MATVEC(TUS,VH,VH1)
      DO 35 JX = 1,3
      X(NTOTS,JX) = VH1(JX) + SYML(JX)
   35 CONTINUE
C     ADDITIONAL X'S CREATED
      CALL VEMA(UOBS,AU,J)
C     CREATE ADDITIONAL SET OF SYMMETRY RELATED UOBS
C     TUS * UOBS * TTUS
      CALL TRIPLE(TUS,AU,TTUS,AUS)
      CALL MAVE(AUS,UOBS,NTOTS)
   30 CONTINUE
      IF(ISIG.LE.0) GO TO 20
      IF(IWU.EQ.1) GO TO 20
C     ADDITIONAL SIGU'S TO BE CREATED IF ISIG.GT.0 AND IWU.NE.1
C ***  FORMERLY SET MM = 1 HERE; NOW USE  I (= EQ POSN NO) INSTEAD
      CALL SGTRAN(TUS,SIGB,SIGU,NTOTS,I)
   20 CONTINUE
      N = NTOT + 1
      DO 200 I = N,NTOTS
      DO 200 J = 1,6
      SIGB(I,J) = SIGU(I,J)
  200 CONTINUE
      CALL OUTP4
      IF(NS.LT.0) RETURN
C      DO NOT PRINT SYMMETRY-EQUIVALENT PARAMS WHEN NS NEGATIVE
C      DO NOT PRINT TRANSFORMED ESD'S WHEN NS NEGATIVE (MAIN,BEFORE 125)
      CALL OUTH6
      CALL OUTP6
      RETURN
      END
