      SUBROUTINE VIBAMP
C ***  Changes by KNT, 18.IV, 1.V, 1991, re roundoff in long table
C ***     -- printing non-integer values in format statements gives
C ***     roundoff, whereas if convert to integer must round first;
C ***     previously I had rounded many values printed F6.4
C ***** Changes by EFM March 1991 to improve delta MSDA output
C *****   When each delta MSDA is printed, skip those with zero atom-
C *****     atom distances (atom is in a special position)
C ***** In the matrix printout, leave these entries blank
C ***** Print another matrix for 'bonded' atoms (distance LE 'DIS',
C *****   input on cell dimension line, default 2.0 A) and statistics
C *****   for these 'bonded' delta MSDAs
C ***  SIGNIFICANT CHANGES, SEPT 1985 (TO AVOID TRANSFER INTO DO LOOP)
C ***    also, 9.IV.87, changes just after 210 and at 235 (label problem)
C ***   10.IV.87:  PRINTS LIST OF MSDA DIFFS ONLY WHEN NVIB .LE. -2
C  CALCULATES MEAN SQUARE DISPLACEMENT AMPLITUDES ('MSDA') IN DIRECTIONS
C        SPECIFIED BY PAIRS OF ATOMS INPUT ON LINES (7A), CONTROLLED BY
C        PARAMETER NVIB ON LINE (3), AND FOR SPECIFIED ATOMS IN SPECI-
C        FIED DIRECTIONS (LINES (7B)), CONTROLLED BY ICSVIB ON LINE (3)
C     WHEN NVIB.LT.0, CALCULATES DISPLACEMENT AMPLITUDES IN DIRECTIONS
C        CORRESPONDING TO THE VECTORS BETWEEN ALL PAIRS OF ATOMS
C        INCLUDED IN THE THERMAL ANALYSIS (AND FOR OTHER ATOMS INPUT IN
C        THE ASYMMETRIC UNIT AS WELL, EXCEPT ISOTROPIC ONES)
C
      COMMON// AIDX(3000)
      COMMON/AIDPAR/AX(150,3),AUOBS(150,6),AUCALC(150,6),WU(150,6),
     1  WU1(150,6)
      COMMON/AMPCLN/NVIB,ICSVIB,NVAT1(40),NVAT2(40),
     1 NCSVIB(10), DCOS(10,3)
      COMMON/AMPCLC/VBAT1(40),VBAT2(40),CSATNM(10,12)
      CHARACTER*4 CSATNM,VBAT1,VBAT2
      COMMON/ATPAR/X(150,3),WT(150),MULT(150),UOBS(150,6),SIGU(150,6),UC
     1ALC(150,6),NUORB(150),SIGB(150,6)
      COMMON /CONT1/ISET,NO,NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,NTO
     1T,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,
     2  IEIG, IMAT, IOUT, IRECAL, IFREQ
      COMMON/CONT3/ISOLV,NTOTS,CONSLV,SUMW,RWUDI,RMS,RMU,gof,sumsig
      COMMON/IAID1/ IAIDX1(1000)
      COMMON/INOUTN/ NPAGE, KOUTP,  DIS, IATWT
      COMMON/INOUTC/ NAME1, ATNAME(150),TISET(20),TITLE,ITBL(29),NAME2
C * * Make common IO assignents
      COMMON/IOSET/LI,LO,LTB
      DIMENSION DEL(3),AUO(3,3),V(3),MSV(31,31),ATOM(31),NPOS(31)
      dimension msv2(31,31)
      DIMENSION AUP(3,3), VV(3), WTT(150)
      EQUIVALENCE (WTT(1),AIDX(451))
      CHARACTER*4 NAME1,ATNAME,TISET,TITLE*80, ITBL*3, NAME2*5
      CHARACTER*4 ATOM,IBLANK,msv,MSV2
      DATA IBLANK/' '/
    1 FORMAT(1H ,'MEAN SQUARE DISPLACEMENT AMPLITUDES (MSDA) IN ANGSTROM
     1S SQUARED FOR ATOMS IN VARIOUS SPECIFIED DIRECTIONS. DIFF IS THE'/
     2'    MSDA FOR ATOM 2 MINUS THE MSDA FOR ATOM 1.'/)
    2 FORMAT(1H ,'  DIRECTIONS DEFINED BY LINES BETWEEN SPECIFIED PAIRS
     1 OF ATOMS:',//,1H ,'ATOM',7X,'ATOM', 8X,
     2          'DIRECTION COSINES RELATIVE TO',10X,'MSDA FROM UOBS',
     3 10X,'SIGMA',12X,'MSDA FROM UCALC',/
     4 ,1H ,1X,' 1',4X,'POS.',2X,'2',4X,'POS.',4X,
     5 'CARTESIAN CRYSTAL AXES',9X,'ATOM 1', 3X,'ATOM 2',3X,'DIFF',5X,
     6 'DIFF',6X,'ATOM 1',3X,'ATOM 2',3X,'DIFF',/)
    3 FORMAT(1H ,1X,A4,2X,I2,3X,A4,2X,I2,3X,3(F8.5,2X),4X,
     1 3(F6.4,3X),2X,F6.4,6X,3(F6.4,3X))
    4 FORMAT(1H ,//,1H ,'  DIRECTIONS DEFINED BY DIRECTION COSINES INPUT
     1:',//,1H ,14X,'DIRECTION COSINES RELATIVE TO',19X,'MSDA FROM',4X,
     2 'MSDA FROM'/,1H ,2X,'NO.',12X,'CARTESIAN CRYSTAL AXES',15X,
     3 'ATOM',7X,'UOBS',8X,'UCALC')
    5 FORMAT(1H ,I4,10X,3(F8.5,2X))
    6 FORMAT(1H+,54X,A4,6X,2(F6.4,7X))
    7 FORMAT(1H ,54X,A4,6X,2(F6.4,7X))
    8 FORMAT(1H ,2X,'AVE. DIFF =',F10.4,/1H ,2X,'R.M.S. DIFF =', F8.4)
    9 FORMAT(1H ,2X,'THE SUM OF THE SQUARES OF (DIFF/SIGMA) FOR ATOM PAI
     *RS FOR WHICH NEITHER ATOM HAS NEG WT OR WT 800.0 OR 999.9 IS:',
     1                               F10.2,/1H ,4X, 'SIGMA HERE IS THE E
     2.S.D. OF DIFFERENCE IN MSDA FOR THE TWO ATOMS IN EACH PAIR.',/
     3 1H ,4X,'THE TOTAL NUMBER OF ATOM PAIRS (NOT INCLUDING ANY WITH AN
     4 ATOM OF WT 800.0, 999.9 OR NEGATIVE) IS', I6)
   10 FORMAT(' MATRIX OF DIFFS OF OBS MSDA. VALUE LISTED IS 10000*MSDA F
     1OR COLUMN ATOM MINUS THAT FOR ROW ATOM'//' ATOM->',1X,31A4)
   11 FORMAT(1H ,A4,1X,31A4)
   12 FORMAT(1H ,'POSN->',1X,31(I2,2X))
   13 format(1H ,2x,'AVE. DIFF. FOR BONDED (distance <',F6.2,')  ATOMS =
     1',F10.4,/1H ,2X,'R.M.S. DIFF =',F8.4)
   14 FORMAT(//' MATRIX OF DIFFS OF OBS MSDA. VALUES FOR BONDED ATOMS'
     1//' ATOM->',1X,31A4)
   16 format(i4)
   17 FORMAT(A80)
   18 FORMAT(//'  *NOTE: TABLE MAY CONTAIN DUPLICATES BECAUSE OF
     1 SYMMETRY!'/)
C
      CALL OUTH6
      WRITE(LO,1)
      IF(NVIB.EQ.0) GO TO 100
      CHI = 0.0
      SDOBS = 0.0
      SDSQ = 0.0
      bdobs = 0.0
      bdobsq = 0.0
      lb = 0
C *** SET SIGDF.EQ.0; OTHERWISE LAST VALUE FROM PRECEDING STRUCTURE
C        PRINTED WHEN ISIG.LE.0
      SIGDF = 0.0
      IF(NS.GE.0.AND.NVIB.LE.-2) WRITE(LO,2)
      IF(NVIB.LT.0) GO TO 200
      WRITE(LO,2)
      DO 80 I = 1,NVIB
      DO 20 K = 1,NTOT
      IF(VBAT1(I).EQ.ATNAME(K)) I1 = K + NA*(NVAT1(I) - 1)
      IF(VBAT2(I).EQ.ATNAME(K)) I2 = K + NA*(NVAT2(I) - 1)
   20 CONTINUE
      XL2 = 0.0
      DO 30 J = 1,3
      DEL(J) = AX(I2,J) - AX(I1,J)
      XL2 = XL2 + DEL(J)*DEL(J)
   30 CONTINUE
      XL2 = SQRT(XL2)
      DO 40 K = 1,3
      V(K) = DEL(K)/XL2
   40 CONTINUE
      CALL VEMA(AUOBS,AUO,I1)
      CALL VMAV(AUO,V,SVO1)
      CALL VEMA(AUOBS,AUO,I2)
      CALL VMAV(AUO,V,SVO2)
      DOBS = SVO1 - SVO2
  255 IF(WTT(I1).EQ.800.0.OR.WTT(I2).EQ.800.0.OR.WTT(I1).EQ.999.9.OR.WTT
     1(I2).EQ.999.9.OR.WTT(I1).LT.0.0.OR.WTT(I2).LT.0.0) GO TO 280
C   SET MSDA DIFFS FOR PAIRS INVOLVING DUMMY ATOMS (WTS 800.0 OR 999.9)
C     OR ATOMS WITH NEG WT (INCL ISOTROPIC ATOMS) ARBITRARILY TO 0.0
C     AND DO NOT INCLUDE SUCH PAIRS IN STATISTICS
C   HOWEVER, MSDA VALUES WILL BE PRINTED IN CASE SOME DUMMY ATOMS WERE
C     USED FOR SPECIAL PURPOSES
      SDOBS = SDOBS + ABS(DOBS)
      SDSQ = SDSQ + DOBS*DOBS
C ***   IF ISIG IS POSITIVE, SIGMAS OF U'S INPUT
      IF(ISIG.LE.0) GO TO 50
C ***   IF ISIG = NTOT, SIGU INPUT FOR ALL ATOMS INPUT.  HOWEVER, IF
C          NA IS LESS THAN NTOT AND ISIG = NA, THEN NO SIGU INPUT FOR
C          THE (NTOT - NA) ATOMS NOT INCLUDED IN THE ANALYSIS.  THESE
C          ATOMS MUST THUS BE OMITTED IN 'CHI SQUARED' CALCULATION.
      IF(ISIG.EQ.NTOT) GO TO 290
      IF(NA.EQ.NTOT) GO TO 290
      IF(I1.GT.NA.AND.I1.LE.NTOT) GO TO 280
      IF(I2.GT.NA.AND.I2.LE.NTOT) GO TO 280
      GO TO 290
  280 SIGDF = 0.0
      GO TO 50
C *** CALCULATE E.S.D. OF DIFF. OF MSDA'S ('SIGDF') IGNORING COVARIANCE
  290 CALL VEMA(SIGU,AUO,I1)
      CALL VEMA(SIGU,AUP,I2)
      DO 300 II = 1,3
      DO 300 JJ = 1,3
  300 AUO(II,JJ) = 2.*(AUO(II,JJ)*AUO(II,JJ) + AUP(II,JJ)*AUP(II,JJ))
      DO 302 II = 1,3
  302 AUO(II,II) = 0.5*AUO(II,II)
C *** ELEMENTS OF AUO NOW CONTAIN THE SUM OF SIGMA SQUARED FOR CORRESP.
C     ELEMENTS OF U FOR THE ATOMS IN THE BOND, WITH AN ADDITIONAL FACTOR
C     OF TWO WITH THE CROSS-TERMS BECAUSE COVAR(IJ,JI) = 1.
      DO 310 II = 1,3
  310 VV(II) = V(II)*V(II)
      CALL VMAV(AUO,VV,SIGDF)
      SIGDF = SQRT(SIGDF)
C *** ASSUME SIGMAS OF SYM-EQUIVALENT U'S INPUT WITH SAME VALUE AS THE
C       SIGMA OF THE CORRESPONDING UNIQUE U
      IF(SIGDF.EQ.0.) GO TO 50
      CHI = CHI + (DOBS/SIGDF)**2
C *** CANNOT CALCULATE MSDA FROM UCALC FOR ATOMS OUTSIDE THE ASYM. UNIT
C          INPUT SINCE AUCALC NOT EVALUATED FOR SUCH ATOMS (SEE CALCUS).
   50 IF(NVAT1(I).GT.1.OR.NVAT2(I).GT.1) GO TO 60
C ***  NVAT1 AND NVAT2 ARE EQUIV POSNS FOR INPUT ATOMS WHEN NVIB.GT.0
      CALL VEMA(AUCALC,AUO,I1)
      CALL VMAV(AUO,V,SVC1)
      CALL VEMA(AUCALC,AUO,I2)
      CALL VMAV(AUO,V,SVC2)
      DCAL = SVC1 - SVC2
      WRITE(LO,3) VBAT1(I),NVAT1(I),VBAT2(I),NVAT2(I),(V(K),K=1,3),
     1 SVO1,SVO2,DOBS,SIGDF,SVC1,SVC2,DCAL
      GO TO 80
   60 WRITE(LO,3) VBAT1(I),NVAT1(I),VBAT2(I),NVAT2(I),(V(K),K=1,3),
     1 SVO1,SVO2,DOBS,SIGDF
   80 CONTINUE
      DNV = NVIB
      AVE = SDOBS/DNV
      RMSD = SQRT(SDSQ/DNV)
      WRITE(LO,8) AVE, RMSD
      WRITE(LO,9) CHI , NVIB
  100 IF(ICSVIB.EQ.0) RETURN
      IF(NVIB.GT.10) CALL OUTH6
      WRITE(LO,4)
      NT = 0
      DO 150 I = 1,ICSVIB
      DO 110 K = 1,3
  110 V(K) = DCOS(I,K)
      L = NCSVIB(I)
      NT = NT + L
C ***     NT IS TALLY FOR PAGINATION
      IF(NT.LE.40) GO TO 115
      CALL OUTH6
      WRITE(LO,4)
      NT = 0
  115 WRITE(LO,5) I,(V(K), K = 1,3)
      DO 150 J = 1,L
      DO 120 K = 1,NTOT
      IF(CSATNM(I,J).EQ.ATNAME(K)) I1 = K
  120 CONTINUE
      CALL VEMA(AUOBS,AUO,I1)
      CALL VMAV(AUO,V,SVO1)
      CALL VEMA(AUCALC,AUO,I1)
      CALL VMAV(AUO,V,SVC1)
      IF(J.EQ.1) GO TO 140
      WRITE(LO,7) CSATNM(I,J),SVO1,SVC1
      GO TO 150
  140 WRITE(LO,6) CSATNM(I,J),SVO1,SVC1
  150 CONTINUE
      RETURN
  200 DO 201 I = 1,31
      DO 201 J = 1,31
      MSV(I,J) = iblank
      msv2(i,j) = IBLANK
  201 CONTINUE
      K = NTOT
      IF(NO.EQ.1) K = K - 1
      NT = 0
      NTT = 0
      NDI = 0
      DO 205 I = 1,NTOTS
      IF(WTT(I).NE.800.0.AND.WTT(I).NE.999.9.AND.WTT(I).GE.0.0) GOTO 204
C ***   ISOTROPIC ATOMS AND ATOMS WITH WTS 800., 999.9 OR NEGATIVE WILL
C ***     BE SKIPPED IN FORMING MSDA MATRIX. FIRST TALLY ALL BUT ISOTROPIC.
      NDI = NDI + 1
C ***   NDI IS A TALLY OF DUMMY ATOMS AND ATOMS WITH NEGATIVE WEIGHT
  204 IF(I.EQ.NTOT) NDIA = NDI
C *** NDIA IS VALUE OF NDI FOR FIRST NTOT ATOMS; USED IN MATRIX PRINT
      IF((I - NDI).GT.32) GO TO 206
  205 CONTINUE
C ***   (I - NDI) NEVER REACHED 33, I.E., (NTOTS - NDI).LE.32
      KK = NTOTS - NDI - 1
      KND = NTOTS
      GO TO 208
  206 KK = 31
      KND = I - 1
C ***   KND TELL HOW MANY ATOMS NEED TO BE INCLUDED FOR MSDA MATRIX.  IT
C ***     MAY BE ALL (IF [I - NDI] IS LESS THAN 33), OR IT MAY BE (I-1)
C ***     (MAX PERMISSIBLE) IF (I-NDI).GT.32.  IF HERE, I IS AT LEAST 33
  208 NI = 1
      IF(NO.EQ.1) NDIA = NDI
      I=0
      IR = 0
C ***   IR IS TALLY FOR ROW ATOMS, LC FOR COLUMN ATOMS FOR MSDA MATRIX
  250 I=I+1
      IF(I.GT.K) GO TO 252
C *** SKIP DUMMY ATOMS AND ATOMS WITH NEG WT IN FORMING MSDA MATRIX
C ***     SKIP  ISOTROPIC ATOMS  FOR LISTING AS WELL
      IF(UOBS(I,2).EQ.0.) GO TO 250
      IF(WTT(I).EQ.800.0.OR.WTT(I).EQ.999.9.OR.WTT(I).LT.0.0) GOTO 2250
      IR = IR + 1
 2250 L=I
      LC = I
  251 L=L+1
      IF(L.GT.NTOTS) GO TO 250
      IF(UOBS(L,2).EQ.0.) GO TO 251
      IF(WTT(L).EQ.800.0.OR.WTT(L).EQ.999.9.OR.WTT(L).LT.0.0) GOTO 2251
C ***  SKIP ISOTROPIC ATOMS FOR EVERYTHING, AND SKIP OTHERS WITH NEG
C         WT AND DUMMY ATOMS FOR MATRIX
      LC = LC + 1
 2251 XL2 = 0.0
      DO 210 J = 1,3
      DEL(J) = AX(I,J) - AX(L,J)
      XL2 = XL2 + DEL(J)*DEL(J)
  210 CONTINUE
C *** OMIT CALCULATION WHEN ATOM LIES ON SYMMETRY ELEMENT.
C ***   (FOR EQUIV ATOMS LYING ON A SYM ELEMENT, XL2 WILL BE 0.0)
      IF(XL2.EQ.0.) GO TO 225
C ***    until 9.IV.87, that was GO TO 251: matrix cols occas labelled wrongly
      XL2 = SQRT(XL2)
      DO 215 J = 1,3
      V(J) = DEL(J)/XL2
  215 CONTINUE
      CALL VEMA(AUOBS,AUO,I)
      CALL VMAV(AUO,V,SVO1)
      CALL VEMA(AUOBS,AUO,L)
      CALL VMAV(AUO,V,SVO2)
      DOBS = SVO2 - SVO1
      IF(WTT(I).EQ.800.0.OR.WTT(I).EQ.999.9.OR.WTT(I).LT.0.0) GOTO 225
      IF(WTT(L).EQ.800.0.OR.WTT(L).EQ.999.9.OR.WTT(L).LT.0.0) GOTO 225
      IF(IR.GT.31.OR.LC.GT.32) GO TO 225
      LN = KND - NDI
C ***    KND = NO OF ATOMS TO BE INCLUDED FOR MATRIX (= NTOTS OR 32, OR
C ***      MORE THAN 32 IF SOME ARE DUMMIES THAT ARE TO BE SKIPPED)
C ***    NDI = NO OF DUMMY (ISO, WTS 800.,999.9) IN FIRST KND
C     DIFFS OF OBS MSDA IN 31 BY 31 MATRIX (FOR UP TO 32 ATOMS).
C     COLUMNS (LL) ARRAYED IN DESCENDING ORDER, FROM LAST TO 2ND ATOM.
      LL = LN - LC + 1
      IF(DOBS.LT.0) GOTO 218
      mobs =(DOBS + 0.00005)*(1.E4)
      WRITE(UNIT=MSV(IR,LL),FMT=16) MOBS
C *** 4 Nov 91 local UNB modification:  The WRITE statement above is
C *** a substitute for the commented out ENCODE statement.  ENCODE
C *** is specific for VAX and CDC fortran and is not an IBM VS fortan
C *** supported statement or function. A similar substitution is
C *** made below statement 218.
C *** encode(4,16,MSV(IR,LL)) mobs
C *** encode is for VAX or CDC fortran; not supported on IBM.
      if(xl2.le.dis)msv2(ir,ll) = msv(ir,ll)
      GOTO 225
  218 mobs =(DOBS - .00005)*1.E4
      WRITE(UNIT=MSV(IR,LL),FMT=16) MOBS
C *** encode(4,16,MSV(IR,LL)) mobs
      if(xl2.le.dis)msv2(ir,ll) = msv(ir,ll)
  225 IF(L.GT.NTOT) GO TO 230
      NL = 1
      KL = L
      GO TO 235
  230 NL = (L - NTOT - 1)/NA + 2
      KL = L - NTOT - NA*(NL - 2)
  235 IF(LC.GT.32.OR.I.GT.1) GO TO 236
      IF(WTT(KL).EQ.800.0.OR.WTT(KL).EQ.999.9.OR.WTT(KL).LT.0.0)GOTO 236
C ***   SKIP DUMMY & NEG-WT ATOMS IN FILLING COL LABELS FOR MSDA MATRIX
      J = KK + 2 - LC
      ATOM(J) = ATNAME(KL)
      NPOS(J) = NL
  236 IF(I.GT.NA.OR.L.GT.NA) GO TO 238
      CALL VEMA(AUCALC,AUO,I)
      CALL VMAV(AUO,V,SVC1)
      CALL VEMA(AUCALC,AUO,L)
      CALL VMAV(AUO,V,SVC2)
      DCAL = ABS(SVC2 - SVC1)
  238 I1 = I
      I2 = L
      IF(WTT(I1).EQ.800.0.OR.WTT(I2).EQ.800.0.OR.WTT(I1).EQ.999.9.OR.WTT
     1(I2).EQ.999.9.OR.WTT(I1).LT.0.0.OR.WTT(I2).LT.0.0) GO TO 1280
C   SET MSDA DIFFS FOR PAIRS INVOLVING DUMMY ATOMS (WTS 800.0 OR 999.9)
C     OR ATOMS WITH NEG WT (INCL ISOTROPIC ATOMS) ARBITRARILY TO 0.0
C     AND DO NOT INCLUDE SUCH PAIRS IN STATISTICS
C   HOWEVER, MSDA VALUES WILL BE PRINTED IN CASE SOME DUMMY ATOMS WERE
C     USED FOR SPECIAL PURPOSES
      if(xl2.gt.dis)go to 2388
      bdobs = bdobs + abs(dobs)
      bdobsq = bdobsq + dobs*dobs
      lb = lb+1
2388  SDOBS = SDOBS + ABS(DOBS)
      SDSQ = SDSQ + DOBS*DOBS
C ***   IF ISIG IS POSITIVE, SIGMAS OF U'S INPUT
      IF(ISIG.LE.0) GO TO 260
C ***   IF ISIG = NTOT, SIGU INPUT FOR ALL ATOMS INPUT.  HOWEVER, IF
C          NA IS LESS THAN NTOT AND ISIG = NA, THEN NO SIGU INPUT FOR
C          THE (NTOT - NA) ATOMS NOT INCLUDED IN THE ANALYSIS.  THESE
C          ATOMS MUST THUS BE OMITTED IN 'CHI SQUARED' CALCULATION.
      IF(ISIG.EQ.NTOT) GO TO 1290
      IF(NA.EQ.NTOT) GO TO 1290
      IF(I1.GT.NA.AND.I1.LE.NTOT) GO TO 1280
      IF(I2.GT.NA.AND.I2.LE.NTOT) GO TO 1280
      GO TO 1290
 1280 SIGDF = 0.0
      GO TO 260
C *** CALCULATE E.S.D. OF DIFF. OF MSDA'S ('SIGDF') IGNORING COVARIANCE
 1290 CALL VEMA(SIGU,AUO,I1)
      CALL VEMA(SIGU,AUP,I2)
      DO 1300 II = 1,3
      DO 1300 JJ = 1,3
 1300 AUO(II,JJ) = 2.*(AUO(II,JJ)*AUO(II,JJ) + AUP(II,JJ)*AUP(II,JJ))
      DO 1302 II = 1,3
 1302 AUO(II,II) = 0.5*AUO(II,II)
C *** ELEMENTS OF AUO NOW CONTAIN THE SUM OF SIGMA SQUARED FOR CORRESP.
C     ELEMENTS OF U FOR THE ATOMS IN THE BOND, WITH AN ADDITIONAL FACTOR
C     OF TWO WITH THE CROSS-TERMS BECAUSE COVAR(IJ,JI) = 1.
      DO 1310 II = 1,3
 1310 VV(II) = V(II)*V(II)
      CALL VMAV(AUO,VV,SIGDF)
      SIGDF = SQRT(SIGDF)
C *** ASSUME SIGMAS OF SYM-EQUIVALENT U'S INPUT WITH SAME VALUE AS THE
C       SIGMA OF THE CORRESPONDING UNIQUE U
      IF(SIGDF.EQ.0.) GO TO 260
      CHI = CHI + (DOBS/SIGDF)**2
  260 IF(I.GT.NA.OR.L.GT.NA) GO TO 240
C ***** Do not print values for vectors with distance zero  EFM 3/91
C *** 10.IV.87 COMPLETE MSDA DIFF LIST PRINTED NOW ONLY IF NVIB.LE.-2
      IF(NS.LT.0.OR.NVIB.GE.-1.or.xl2.eq.0.) GO TO 245
      WRITE(LO,3) ATNAME(I), NI,ATNAME(KL),NL,(V(J),J=1,3),SVO1,SVO2,D
     &OBS,SIGDF,SVC1,SVC2,DCAL
      GO TO 245
  240 IF(NS.LT.0.OR.NVIB.GE.-1.or.xl2.eq.0.) GO TO 245
      WRITE(LO,3) ATNAME(I), NI,ATNAME(KL),NL,(V(J),J=1,3),SVO1,SVO2,D
     &OBS,SIGDF
  245 XW1 = WTT(I1)
      XW2 = WTT(I2)
      IF(XW1.NE.800.0.AND.XW2.NE.800.0.AND.XW1.NE.999.9.AND.XW2.NE.999.9
     1.AND.XW1.GE.0.AND.XW2.GE.0.and.xl2.gt.0.) NTT = NTT + 1
C ***** Do not tally vectors with distances zero EFM 3/91
C ***  ATOMS WITH WTS 800., 999.9 OR NEGATIVE (INCL ISOTROPIC ATOMS) HAD
C         THEIR MSDA DIFFS WITH ANY OTHER ATOM SET TO 0.0; PAIRS THAT
C         INVOLVE SUCH ATOMS NOT TALLIED (NTT IS TALLY OF ATOM-PAIRS)
      NT = NT + 1
C ***   NT IS A TALLY FOR PAGINATION
      IF(NT.LE.49) GO TO 251
      NT = 0
C ***  PRINT LIST ONLY IF NS.GE.0 AND NVIB.LE.-2; NEED NO HEADINGS OTHERWISE
      IF(NS.LT.0.OR.NVIB.GE.-1) GO TO 251
      CALL OUTH6
      WRITE(LO,2)
      GO TO 251
  252 DNTT = NTT
      AVE = SDOBS/DNTT
      RMSD = SQRT(SDSQ/DNTT)
      dlb=lb
      aveb= bdobs/dlb
      rmsb=sqrt(bdobsq/dlb)
      CALL OUTH6
      WRITE(LTB,17) TITLE
      WRITE(LO,10) (ATOM(J), J = 1,KK)
      WRITE(LO,12) (NPOS(J), J = 1,KK)
C *****MATRIX ALSO WRITTEN TO UNIT 11 FOR EDITING AND SEPARATE PRINTING
C * * In PC version UNIT 11 output is sent to UNIT LTB(=4)
      WRITE(LTB,10) (ATOM(J), J = 1,KK)
      WRITE(LTB,12) (NPOS(J), J = 1,KK)
C     THIS PRINTS HEADING FOR MSV MATRIX, COLUMNS IN DESCENDING ORDER
      KL = NTOT - NDIA
      IF(KL.GT.32) KL = 32
      IF(NO.EQ.1) KL = KL - 1
      KJ = KK + 1
      DO 270 I = 1,KL
      KJ = KJ - 1
      WRITE(LTB,11) ATNAME(I),(MSV(I,J), J = 1,KJ)
  270 WRITE(LO,11) ATNAME(I),(MSV(I,J), J = 1,KJ)
      WRITE(LTB,8)AVE, RMSD
      WRITE(LTB,9)CHI, NTT
      WRITE(LO,8) AVE,RMSD
      WRITE(LO,9) CHI, NTT
C ***** MATRIX FOR BONDED ATOMS ADDED EFM 3/91
      call outh6
      WRITE(LO,14) (ATOM(J), J = 1,KK)
      WRITE(LO,12) (NPOS(J), J = 1,KK)
      WRITE(LTB,14) (ATOM(J), J = 1,KK)
      WRITE(LTB,12) (NPOS(J), J = 1,KK)
C     THIS PRINTS HEADING FOR MSV2 MATRIX, COLUMNS IN DESCENDING ORDER
      KL = NTOT - NDIA
      IF(KL.GT.32) KL = 32
      IF(NO.EQ.1) KL = KL - 1
      KJ = KK + 1
      DO 2700 I = 1,KL
      KJ = KJ - 1
      WRITE(LTB,11) ATNAME(I),(MSV2(I,J), J = 1,KJ)
 2700 WRITE(LO,11) ATNAME(I),(MSV2(I,J), J = 1,KJ)
      WRITE(LTB,13) DIS, AVEB, RMSB
      WRITE(LO,13) dis,aveb,rmsb
      WRITE(LTB,18)
      WRITE(LO,18)
C ***   NOW SET NVIB = 11 SO GET NEW PAGE IF ICSVIB.NE.0 (SEE AFTER 100)
      NVIB = 11
      GO TO 100
      END
